<?php
/* ====================
[BEGIN_SED_EXTPLUGIN]
Code=recentcomments
Part=main
File=recentcomments
Hooks=header.tags
Tags=header.tpl:{PLUGIN_LATESTCOMMENTS}
Order=10
[END_SED_EXTPLUGIN]
==================== */

/**
 * Recent comments on index page
 *
 * @package Cotonti
 * @version 0.0.4
 * @author Dayver
 * @copyright (c) Cotonti Team 2009
 * @license BSD
 */

defined('SED_CODE') or die('Wrong URL.');

require_once(sed_langfile('recentcomments'));

$comd = sed_import('comd', 'G', 'INT');
$comd = empty($comd) ? 0 : (int) $comd;

if(!$latestcomments && $cfg['plugin']['recentcomments']['commentsperpage'] > 0)
{
	$latestcomments = new XTemplate(sed_skinfile('recentcomments', true));

	$totalitems = sed_sql_result(sed_sql_query("SELECT COUNT(DISTINCT com_code) FROM $db_com WHERE com_isspecial=0"), 0, 0);

	if($cfg['plugin']['recentcomments']['ajax'] && $cfg['jquery'])
	{
		$pagnav = sed_pagination(sed_url('index'), $comd, $totalitems, $cfg['plugin']['recentcomments']['commentsperpage'], "comd", "ajaxSend", "url: '".sed_url('plug','r=recentcomments')."', divId: 'reloadcommblock', errMsg: '".$L['ajaxSenderror']."'");
		list($pagination_prev, $pagination_next) = sed_pagination_pn(sed_url('index'), $comd, $totalitems, $cfg['plugin']['recentcomments']['commentsperpage'], TRUE, "comd", "ajaxSend", "url: '".sed_url('plug','r=recentcomments')."', divId: 'reloadcommblock', errMsg: '".$L['ajaxSenderror']."'");
	}
	else
	{
		$pagnav = sed_pagination(sed_url('index'), $comd, $totalitems, $cfg['plugin']['recentcomments']['commentsperpage'], "comd");
		list($pagination_prev, $pagination_next) = sed_pagination_pn(sed_url('index'), $comd, $totalitems, $cfg['plugin']['recentcomments']['commentsperpage'], TRUE, "comd");
	}

	$warnings = ($totalitems == 0) ? $L['plu_empty_comm'] : '';

	$sqlcom = sed_sql_query("SELECT MAX(com_id) AS _id, MAX(com_date) AS _date FROM $db_com WHERE com_isspecial=0 GROUP BY com_code ORDER BY _date DESC LIMIT $comd, ".$cfg['plugin']['recentcomments']['commentsperpage']);

	$com_latest = array();
	while($row = sed_sql_fetcharray($sqlcom))
	{
		$com_latest[] = $row['_id'];
	}

	$sqlcom2 = sed_sql_query("SELECT * FROM $db_com WHERE com_id IN('".implode("','",$com_latest)."') ORDER BY com_date DESC");

	$i = 0;
	$current_page_cat = $pag['page_cat']; //

	while($row = sed_sql_fetcharray($sqlcom2))
	{
		$com_code = $row['com_code'];
		$j = substr($com_code, 0, 1);
		$k = substr($com_code, 1);

		switch($j)
		{
			case 'p':
			//
			$sqlcom2_2 = sed_sql_query("SELECT * FROM $db_pages WHERE page_id = $k LIMIT 1");
			while($row2 = sed_sql_fetcharray($sqlcom2_2))
			{
				$page_title = $row2['page_title'];
				$page_alias = $row2['page_alias'];
				$pag['page_cat'] = $row2['page_cat'];
			}
			//
			$lnk = (empty($page_alias)) ? sed_url('page', "id=".$k)."#c".$row['com_id'] : sed_url('page', "al=".$page_alias)."#c".$row['com_id'];
			$comtitle = $page_title;
			$latestcomments -> assign(array(
				"RECENTCOMMENTS_ROW_PAGE_CAT" => sed_build_catpath($row2['page_cat'], '<a href="%1$s">%2$s</a>'),
				"RECENTCOMMENTS_ROW_PAGE_KEY" => $row2['page_key'],
				"RECENTCOMMENTS_ROW_PAGE_DESC" => $row2['page_desc'],
				"RECENTCOMMENTS_ROW_PAGE_ID" =>$k,
				"RECENTCOMMENTS_ROW_PAGE_ALIAS" => $page_alias
			));
			break;

			case 'v':
			//
			$sqlcom2_2 = sed_sql_query("SELECT * FROM $db_polls WHERE poll_id = $k LIMIT 1");
			while($row2 = sed_sql_fetcharray($sqlcom2_2))
			{
				$poll_title = sed_parse(sed_cc($row2['poll_text']), 1, 1, 1);
			}
			//
			$lnk = sed_url('polls', "id=".$k)."#c".$row['com_id'];
			$comtitle = $poll_title;
			/*$latestcomments -> assign(array(
				"RECENTCOMMENTS_ROW_POLL_" => $row3['poll_text']
			));*/
			break;
		}

		$latestcomments -> assign(array(
			"RECENTCOMMENTS_ROW_HREF" => $lnk,
			"RECENTCOMMENTS_ROW_ITEM_TITLE" => $comtitle,
			"RECENTCOMMENTS_ROW_DATE" => date($cfg['formatmonthdayhourmin'], $row['com_date'] + $usr['timezone'] * 3600),
			"RECENTCOMMENTS_ROW_AUTHORNAME" => $row['com_author'],
			"RECENTCOMMENTS_ROW_AUTHORID" => $row['com_authorid'],
			"RECENTCOMMENTS_ROW_AUTHOR" => sed_build_user($row['com_authorid'], sed_cc($row['com_author'])),
			"RECENTCOMMENTS_ROW_COM_TEXT" => $row['com_text']
		));
		$latestcomments -> parse("RECENTCOMMENTS.COMM_ROW");

		$i++;
	}

	$pag['page_cat'] = $current_page_cat; //

	$latestcomments -> assign(array(
		"RECENTCOMMENTS_AJAX_OPENDIVID" => 'reloadcommblock',
		"RECENTCOMMENTS_WARNINGS" => $warnings,
		"RECENTCOMMENTS_PAGINATION_PREV" => $pagination_prev,
		"RECENTCOMMENTS_PAGNAV" => $pagnav,
		"RECENTCOMMENTS_PAGINATION_NEXT" => $pagination_next,
		"RECENTCOMMENTS_TOTALITEMS" => $totalitems,
		"RECENTCOMMENTS_COUNTER_ROW" => $i
	));
	$latestcomments -> parse("RECENTCOMMENTS");
	$taglatestcomments = $latestcomments -> text("RECENTCOMMENTS");

	sed_cache_store('taglatestcomments', $taglatestcomments, 5);
}

$t -> assign(array("PLUGIN_LATESTCOMMENTS" => $taglatestcomments));

?>