/*
MySQL Data Transfer
Source Host: localhost
Source Database: veronese
Target Host: localhost
Target Database: veronese
Date: 10.10.2009 1:57:13
*/

SET FOREIGN_KEY_CHECKS=0;
-- ----------------------------
-- Table structure for sed_auth
-- ----------------------------
CREATE TABLE `sed_auth` (
  `auth_id` mediumint(8) NOT NULL auto_increment,
  `auth_groupid` int(11) NOT NULL default '0',
  `auth_code` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `auth_option` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `auth_rights` tinyint(1) unsigned NOT NULL default '0',
  `auth_rights_lock` tinyint(1) unsigned NOT NULL default '0',
  `auth_setbyuserid` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`auth_id`),
  KEY `auth_groupid` (`auth_groupid`),
  KEY `auth_code` (`auth_code`)
) ENGINE=MyISAM AUTO_INCREMENT=361 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_banlist
-- ----------------------------
CREATE TABLE `sed_banlist` (
  `banlist_id` int(11) NOT NULL auto_increment,
  `banlist_ip` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `banlist_email` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `banlist_reason` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `banlist_expire` int(11) default '0',
  PRIMARY KEY  (`banlist_id`),
  KEY `banlist_ip` (`banlist_ip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_bbcode
-- ----------------------------
CREATE TABLE `sed_bbcode` (
  `bbc_id` int(11) NOT NULL auto_increment,
  `bbc_name` varchar(100) collate utf8_unicode_ci NOT NULL,
  `bbc_mode` enum('str','ereg','pcre','callback') collate utf8_unicode_ci NOT NULL default 'str',
  `bbc_pattern` varchar(255) collate utf8_unicode_ci NOT NULL,
  `bbc_replacement` text collate utf8_unicode_ci NOT NULL,
  `bbc_container` tinyint(4) NOT NULL default '1',
  `bbc_enabled` tinyint(1) NOT NULL default '1',
  `bbc_priority` tinyint(3) unsigned NOT NULL default '128',
  `bbc_plug` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `bbc_postrender` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`bbc_id`),
  KEY `bbc_enabled` (`bbc_enabled`),
  KEY `bbc_priority` (`bbc_priority`)
) ENGINE=MyISAM AUTO_INCREMENT=118 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_cache
-- ----------------------------
CREATE TABLE `sed_cache` (
  `c_name` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `c_expire` int(11) NOT NULL default '0',
  `c_auto` tinyint(1) NOT NULL default '1',
  `c_value` text collate utf8_unicode_ci,
  PRIMARY KEY  (`c_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_com
-- ----------------------------
CREATE TABLE `sed_com` (
  `com_id` int(11) NOT NULL auto_increment,
  `com_code` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `com_author` varchar(100) collate utf8_unicode_ci NOT NULL,
  `com_authorid` int(11) default NULL,
  `com_authorip` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `com_text` text collate utf8_unicode_ci NOT NULL,
  `com_html` text collate utf8_unicode_ci,
  `com_date` int(11) NOT NULL default '0',
  `com_count` int(11) NOT NULL default '0',
  `com_isspecial` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`com_id`),
  KEY `com_code` (`com_code`)
) ENGINE=MyISAM AUTO_INCREMENT=18 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_config
-- ----------------------------
CREATE TABLE `sed_config` (
  `config_owner` varchar(24) collate utf8_unicode_ci NOT NULL default 'core',
  `config_cat` varchar(24) collate utf8_unicode_ci NOT NULL default '',
  `config_order` char(2) collate utf8_unicode_ci NOT NULL default '00',
  `config_name` varchar(32) collate utf8_unicode_ci NOT NULL default '',
  `config_type` tinyint(2) NOT NULL default '0',
  `config_value` text collate utf8_unicode_ci NOT NULL,
  `config_default` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `config_text` varchar(255) collate utf8_unicode_ci NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_core
-- ----------------------------
CREATE TABLE `sed_core` (
  `ct_id` mediumint(8) NOT NULL auto_increment,
  `ct_code` varchar(24) collate utf8_unicode_ci NOT NULL default '',
  `ct_title` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `ct_version` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `ct_state` tinyint(1) unsigned NOT NULL default '1',
  `ct_lock` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ct_id`),
  KEY `ct_code` (`ct_code`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_extra_fields
-- ----------------------------
CREATE TABLE `sed_extra_fields` (
  `field_location` varchar(255) collate utf8_unicode_ci NOT NULL,
  `field_name` varchar(255) collate utf8_unicode_ci NOT NULL,
  `field_type` varchar(255) collate utf8_unicode_ci NOT NULL,
  `field_html` text collate utf8_unicode_ci NOT NULL,
  `field_variants` text collate utf8_unicode_ci NOT NULL,
  `field_description` text collate utf8_unicode_ci NOT NULL,
  KEY `field_location` (`field_location`),
  KEY `field_name` (`field_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_forum_posts
-- ----------------------------
CREATE TABLE `sed_forum_posts` (
  `fp_id` mediumint(8) unsigned NOT NULL auto_increment,
  `fp_topicid` mediumint(8) NOT NULL default '0',
  `fp_sectionid` smallint(5) NOT NULL default '0',
  `fp_posterid` int(11) NOT NULL default '-1',
  `fp_postername` varchar(100) collate utf8_unicode_ci NOT NULL,
  `fp_creation` int(11) NOT NULL default '0',
  `fp_updated` int(11) NOT NULL default '0',
  `fp_updater` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `fp_text` text collate utf8_unicode_ci NOT NULL,
  `fp_posterip` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `fp_html` text collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (`fp_id`),
  UNIQUE KEY `fp_topicid` (`fp_topicid`,`fp_id`),
  KEY `fp_updated` (`fp_creation`),
  KEY `fp_posterid` (`fp_posterid`),
  KEY `fp_sectionid` (`fp_sectionid`)
) ENGINE=MyISAM AUTO_INCREMENT=26 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_forum_sections
-- ----------------------------
CREATE TABLE `sed_forum_sections` (
  `fs_id` smallint(5) unsigned NOT NULL auto_increment,
  `fs_state` tinyint(1) unsigned NOT NULL default '0',
  `fs_order` smallint(5) unsigned NOT NULL default '0',
  `fs_title` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `fs_category` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `fs_desc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `fs_icon` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `fs_lt_id` int(11) NOT NULL default '0',
  `fs_lt_title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `fs_lt_date` int(11) NOT NULL default '0',
  `fs_lt_posterid` int(11) NOT NULL default '-1',
  `fs_lt_postername` varchar(100) collate utf8_unicode_ci NOT NULL,
  `fs_autoprune` int(11) NOT NULL default '0',
  `fs_allowusertext` tinyint(1) NOT NULL default '1',
  `fs_allowbbcodes` tinyint(1) NOT NULL default '1',
  `fs_allowsmilies` tinyint(1) NOT NULL default '1',
  `fs_allowprvtopics` tinyint(1) NOT NULL default '0',
  `fs_countposts` tinyint(1) NOT NULL default '1',
  `fs_topiccount` mediumint(8) NOT NULL default '0',
  `fs_topiccount_pruned` int(11) default '0',
  `fs_postcount` mediumint(8) NOT NULL default '0',
  `fs_postcount_pruned` int(11) default '0',
  `fs_viewcount` mediumint(8) NOT NULL default '0',
  `fs_masterid` smallint(5) unsigned NOT NULL default '0',
  `fs_mastername` varchar(128) collate utf8_unicode_ci NOT NULL,
  `fs_allowviewers` tinyint(1) NOT NULL default '1',
  `fs_allowpolls` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`fs_id`),
  KEY `fs_order` (`fs_order`)
) ENGINE=MyISAM AUTO_INCREMENT=24 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_forum_structure
-- ----------------------------
CREATE TABLE `sed_forum_structure` (
  `fn_id` mediumint(8) NOT NULL auto_increment,
  `fn_path` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `fn_code` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `fn_tpl` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `fn_title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `fn_desc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `fn_icon` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `fn_defstate` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`fn_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_forum_topics
-- ----------------------------
CREATE TABLE `sed_forum_topics` (
  `ft_id` mediumint(8) unsigned NOT NULL auto_increment,
  `ft_mode` tinyint(1) unsigned NOT NULL default '0',
  `ft_state` tinyint(1) unsigned NOT NULL default '0',
  `ft_sticky` tinyint(1) unsigned NOT NULL default '0',
  `ft_tag` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `ft_sectionid` mediumint(8) NOT NULL default '0',
  `ft_title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ft_desc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ft_creationdate` int(11) NOT NULL default '0',
  `ft_updated` int(11) NOT NULL default '0',
  `ft_postcount` mediumint(8) NOT NULL default '0',
  `ft_viewcount` mediumint(8) NOT NULL default '0',
  `ft_lastposterid` int(11) NOT NULL default '-1',
  `ft_lastpostername` varchar(100) collate utf8_unicode_ci NOT NULL,
  `ft_firstposterid` int(11) NOT NULL default '-1',
  `ft_firstpostername` varchar(100) collate utf8_unicode_ci NOT NULL,
  `ft_poll` int(11) default '0',
  `ft_movedto` int(11) default '0',
  `ft_preview` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`ft_id`),
  KEY `ft_updated` (`ft_updated`),
  KEY `ft_mode` (`ft_mode`),
  KEY `ft_state` (`ft_state`),
  KEY `ft_sticky` (`ft_sticky`),
  KEY `ft_sectionid` (`ft_sectionid`),
  KEY `ft_movedto` (`ft_movedto`)
) ENGINE=MyISAM AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_groups
-- ----------------------------
CREATE TABLE `sed_groups` (
  `grp_id` int(11) NOT NULL auto_increment,
  `grp_alias` varchar(24) collate utf8_unicode_ci NOT NULL default '',
  `grp_level` tinyint(2) NOT NULL default '1',
  `grp_disabled` tinyint(1) NOT NULL default '0',
  `grp_hidden` tinyint(1) NOT NULL default '0',
  `grp_title` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `grp_desc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `grp_icon` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `grp_pfs_maxfile` int(11) NOT NULL default '0',
  `grp_pfs_maxtotal` int(11) NOT NULL default '0',
  `grp_ownerid` int(11) NOT NULL default '0',
  `grp_maintenance` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`grp_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_groups_users
-- ----------------------------
CREATE TABLE `sed_groups_users` (
  `gru_userid` int(11) NOT NULL default '0',
  `gru_groupid` int(11) NOT NULL default '0',
  `gru_state` tinyint(1) NOT NULL default '0',
  `gru_extra1` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `gru_extra2` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  UNIQUE KEY `gru_groupid` (`gru_groupid`,`gru_userid`),
  KEY `gru_userid` (`gru_userid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_logger
-- ----------------------------
CREATE TABLE `sed_logger` (
  `log_id` mediumint(11) NOT NULL auto_increment,
  `log_date` int(11) NOT NULL default '0',
  `log_ip` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `log_name` varchar(100) collate utf8_unicode_ci NOT NULL,
  `log_group` varchar(4) collate utf8_unicode_ci NOT NULL default 'def',
  `log_text` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`log_id`)
) ENGINE=MyISAM AUTO_INCREMENT=86 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_online
-- ----------------------------
CREATE TABLE `sed_online` (
  `online_id` int(11) NOT NULL auto_increment,
  `online_ip` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `online_name` varchar(100) collate utf8_unicode_ci NOT NULL,
  `online_lastseen` int(11) NOT NULL default '0',
  `online_location` varchar(32) collate utf8_unicode_ci NOT NULL default '',
  `online_subloc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `online_userid` int(11) NOT NULL default '0',
  `online_shield` int(11) NOT NULL default '0',
  `online_action` varchar(32) collate utf8_unicode_ci NOT NULL default '',
  `online_hammer` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`online_id`),
  KEY `online_lastseen` (`online_lastseen`),
  KEY `online_userid` (`online_userid`),
  KEY `online_name` (`online_name`)
) ENGINE=MyISAM AUTO_INCREMENT=66 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_pages
-- ----------------------------
CREATE TABLE `sed_pages` (
  `page_id` int(11) unsigned NOT NULL auto_increment,
  `page_state` tinyint(1) unsigned NOT NULL default '0',
  `page_type` tinyint(1) default '0',
  `page_cat` varchar(255) collate utf8_unicode_ci default NULL,
  `page_key` varchar(16) collate utf8_unicode_ci default NULL,
  `page_extra1` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `page_extra2` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `page_extra3` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `page_extra4` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `page_extra5` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `page_title` varchar(255) collate utf8_unicode_ci default NULL,
  `page_desc` varchar(255) collate utf8_unicode_ci default NULL,
  `page_text` mediumtext collate utf8_unicode_ci,
  `page_author` varchar(100) collate utf8_unicode_ci NOT NULL,
  `page_ownerid` int(11) NOT NULL default '0',
  `page_date` int(11) NOT NULL default '0',
  `page_begin` int(11) NOT NULL default '0',
  `page_expire` int(11) NOT NULL default '0',
  `page_file` tinyint(4) default NULL,
  `page_url` varchar(255) collate utf8_unicode_ci default NULL,
  `page_size` varchar(16) collate utf8_unicode_ci default NULL,
  `page_count` mediumint(8) unsigned default '0',
  `page_rating` decimal(5,2) NOT NULL default '0.00',
  `page_comcount` mediumint(8) unsigned default '0',
  `page_filecount` mediumint(8) unsigned default '0',
  `page_alias` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `page_html` mediumtext collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (`page_id`),
  KEY `page_cat` (`page_cat`),
  KEY `page_alias` (`page_alias`),
  KEY `page_state` (`page_state`),
  KEY `page_date` (`page_date`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_pfs
-- ----------------------------
CREATE TABLE `sed_pfs` (
  `pfs_id` int(11) NOT NULL auto_increment,
  `pfs_userid` int(11) NOT NULL default '0',
  `pfs_date` int(11) NOT NULL default '0',
  `pfs_file` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pfs_extension` varchar(8) collate utf8_unicode_ci NOT NULL default '',
  `pfs_folderid` int(11) NOT NULL default '0',
  `pfs_desc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pfs_size` int(11) NOT NULL default '0',
  `pfs_count` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pfs_id`),
  KEY `pfs_userid` (`pfs_userid`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_pfs_folders
-- ----------------------------
CREATE TABLE `sed_pfs_folders` (
  `pff_id` int(11) NOT NULL auto_increment,
  `pff_userid` int(11) NOT NULL default '0',
  `pff_date` int(11) NOT NULL default '0',
  `pff_updated` int(11) NOT NULL default '0',
  `pff_title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pff_desc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pff_ispublic` tinyint(1) NOT NULL default '0',
  `pff_isgallery` tinyint(1) NOT NULL default '0',
  `pff_count` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pff_id`),
  KEY `pff_userid` (`pff_userid`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_plugins
-- ----------------------------
CREATE TABLE `sed_plugins` (
  `pl_id` mediumint(8) NOT NULL auto_increment,
  `pl_hook` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `pl_code` varchar(24) collate utf8_unicode_ci NOT NULL default '',
  `pl_part` varchar(24) collate utf8_unicode_ci NOT NULL default '',
  `pl_title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pl_file` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pl_order` tinyint(2) unsigned NOT NULL default '10',
  `pl_active` tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (`pl_id`)
) ENGINE=MyISAM AUTO_INCREMENT=55 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_pm
-- ----------------------------
CREATE TABLE `sed_pm` (
  `pm_id` int(11) unsigned NOT NULL auto_increment,
  `pm_state` tinyint(2) NOT NULL default '0',
  `pm_date` int(11) NOT NULL default '0',
  `pm_fromuserid` int(11) NOT NULL default '0',
  `pm_fromuser` varchar(100) collate utf8_unicode_ci NOT NULL,
  `pm_touserid` int(11) NOT NULL default '0',
  `pm_title` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pm_text` text collate utf8_unicode_ci NOT NULL,
  `pm_html` text collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (`pm_id`),
  KEY `pm_fromuserid` (`pm_fromuserid`),
  KEY `pm_touserid` (`pm_touserid`)
) ENGINE=MyISAM AUTO_INCREMENT=29 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_polls
-- ----------------------------
CREATE TABLE `sed_polls` (
  `poll_id` mediumint(8) NOT NULL auto_increment,
  `poll_type` varchar(100) collate utf8_unicode_ci NOT NULL default 'index',
  `poll_code` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `poll_state` tinyint(1) NOT NULL default '0',
  `poll_creationdate` int(11) NOT NULL default '0',
  `poll_text` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `poll_multiple` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`poll_id`),
  KEY `poll_creationdate` (`poll_creationdate`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_polls_options
-- ----------------------------
CREATE TABLE `sed_polls_options` (
  `po_id` mediumint(8) unsigned NOT NULL auto_increment,
  `po_pollid` mediumint(8) unsigned NOT NULL default '0',
  `po_text` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `po_count` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`po_id`),
  KEY `po_pollid` (`po_pollid`)
) ENGINE=MyISAM AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_polls_voters
-- ----------------------------
CREATE TABLE `sed_polls_voters` (
  `pv_id` mediumint(8) unsigned NOT NULL auto_increment,
  `pv_pollid` mediumint(8) NOT NULL default '0',
  `pv_userid` mediumint(8) NOT NULL default '0',
  `pv_userip` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`pv_id`),
  KEY `pv_pollid` (`pv_pollid`)
) ENGINE=MyISAM AUTO_INCREMENT=22 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_rated
-- ----------------------------
CREATE TABLE `sed_rated` (
  `rated_id` int(11) unsigned NOT NULL auto_increment,
  `rated_code` varchar(16) collate utf8_unicode_ci default NULL,
  `rated_userid` int(11) default NULL,
  `rated_value` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`rated_id`),
  KEY `rated_code` (`rated_code`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_ratings
-- ----------------------------
CREATE TABLE `sed_ratings` (
  `rating_id` int(11) NOT NULL auto_increment,
  `rating_code` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `rating_state` tinyint(2) NOT NULL default '0',
  `rating_average` decimal(5,2) NOT NULL default '0.00',
  `rating_creationdate` int(11) NOT NULL default '0',
  `rating_text` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`rating_id`),
  KEY `rating_code` (`rating_code`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_referers
-- ----------------------------
CREATE TABLE `sed_referers` (
  `ref_url` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ref_date` int(11) unsigned NOT NULL default '0',
  `ref_count` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ref_url`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_stats
-- ----------------------------
CREATE TABLE `sed_stats` (
  `stat_name` varchar(32) collate utf8_unicode_ci NOT NULL default '',
  `stat_value` int(11) NOT NULL default '0',
  PRIMARY KEY  (`stat_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_structure
-- ----------------------------
CREATE TABLE `sed_structure` (
  `structure_id` mediumint(8) NOT NULL auto_increment,
  `structure_code` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `structure_path` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `structure_tpl` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `structure_title` varchar(100) collate utf8_unicode_ci NOT NULL,
  `structure_desc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `structure_icon` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `structure_group` tinyint(1) NOT NULL default '0',
  `structure_order` varchar(16) collate utf8_unicode_ci NOT NULL default 'title.asc',
  `structure_pagecount` mediumint(8) NOT NULL default '0',
  `structure_comments` tinyint(1) NOT NULL default '1',
  `structure_ratings` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`structure_id`),
  KEY `structure_path` (`structure_path`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_tag_references
-- ----------------------------
CREATE TABLE `sed_tag_references` (
  `tag` varchar(255) collate utf8_unicode_ci NOT NULL,
  `tag_item` int(11) NOT NULL,
  `tag_area` varchar(50) collate utf8_unicode_ci NOT NULL default 'pages',
  PRIMARY KEY  (`tag`,`tag_area`,`tag_item`),
  KEY `tag_item` (`tag_item`),
  KEY `tag_area` (`tag_area`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_tags
-- ----------------------------
CREATE TABLE `sed_tags` (
  `tag` varchar(255) collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (`tag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_trash
-- ----------------------------
CREATE TABLE `sed_trash` (
  `tr_id` int(11) NOT NULL auto_increment,
  `tr_date` int(11) unsigned NOT NULL default '0',
  `tr_type` varchar(24) collate utf8_unicode_ci NOT NULL default '',
  `tr_title` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `tr_itemid` varchar(24) collate utf8_unicode_ci NOT NULL default '',
  `tr_trashedby` int(11) NOT NULL default '0',
  `tr_datas` mediumblob,
  PRIMARY KEY  (`tr_id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Table structure for sed_users
-- ----------------------------
CREATE TABLE `sed_users` (
  `user_id` int(11) unsigned NOT NULL auto_increment,
  `user_banexpire` int(11) default '0',
  `user_name` varchar(100) collate utf8_unicode_ci NOT NULL,
  `user_password` varchar(32) collate utf8_unicode_ci NOT NULL default '',
  `user_maingrp` int(11) NOT NULL default '4',
  `user_country` char(2) collate utf8_unicode_ci NOT NULL default '',
  `user_text` text collate utf8_unicode_ci NOT NULL,
  `user_avatar` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `user_photo` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `user_signature` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `user_extra1` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `user_extra2` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `user_extra3` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `user_extra4` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `user_extra5` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `user_extra6` text collate utf8_unicode_ci,
  `user_extra7` text collate utf8_unicode_ci,
  `user_extra8` text collate utf8_unicode_ci,
  `user_extra9` text collate utf8_unicode_ci,
  `user_occupation` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `user_location` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `user_timezone` decimal(2,1) NOT NULL default '0.0',
  `user_birthdate` date NOT NULL default '1970-01-01',
  `user_gender` char(1) collate utf8_unicode_ci NOT NULL default 'U',
  `user_irc` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `user_msn` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `user_icq` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `user_website` varchar(128) collate utf8_unicode_ci NOT NULL default '',
  `user_email` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `user_hideemail` tinyint(1) unsigned NOT NULL default '1',
  `user_pmnotify` tinyint(1) unsigned NOT NULL default '0',
  `user_newpm` tinyint(1) unsigned NOT NULL default '0',
  `user_skin` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `user_lang` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `user_regdate` int(11) NOT NULL default '0',
  `user_lastlog` int(11) NOT NULL default '0',
  `user_lastvisit` int(11) NOT NULL default '0',
  `user_lastip` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `user_logcount` int(11) unsigned NOT NULL default '0',
  `user_postcount` int(11) default '0',
  `user_sid` char(32) collate utf8_unicode_ci NOT NULL default '',
  `user_lostpass` char(32) collate utf8_unicode_ci NOT NULL default '',
  `user_auth` text collate utf8_unicode_ci,
  `user_theme` varchar(16) collate utf8_unicode_ci NOT NULL default '',
  `user_hashsalt` char(16) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`user_id`),
  KEY `user_password` (`user_password`),
  KEY `user_regdate` (`user_regdate`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- ----------------------------
-- Records 
-- ----------------------------
INSERT INTO `sed_auth` VALUES ('1', '1', 'admin', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('2', '2', 'admin', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('3', '3', 'admin', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('4', '4', 'admin', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('5', '5', 'admin', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('116', '6', 'admin', 'a', '1', '0', '1');
INSERT INTO `sed_auth` VALUES ('6', '1', 'comments', 'a', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('7', '2', 'comments', 'a', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('8', '3', 'comments', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('9', '4', 'comments', 'a', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('10', '5', 'comments', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('117', '6', 'comments', 'a', '131', '0', '1');
INSERT INTO `sed_auth` VALUES ('46', '1', 'forums', '1', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('47', '2', 'forums', '1', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('48', '3', 'forums', '1', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('49', '4', 'forums', '1', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('50', '5', 'forums', '1', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('125', '6', 'forums', '1', '131', '0', '1');
INSERT INTO `sed_auth` VALUES ('264', '1', 'forums', '10', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('261', '2', 'forums', '10', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('262', '3', 'forums', '10', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('263', '4', 'forums', '10', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('259', '5', 'forums', '10', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('260', '6', 'forums', '10', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('270', '1', 'forums', '11', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('267', '2', 'forums', '11', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('268', '3', 'forums', '11', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('269', '4', 'forums', '11', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('265', '5', 'forums', '11', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('266', '6', 'forums', '11', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('276', '1', 'forums', '12', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('273', '2', 'forums', '12', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('274', '3', 'forums', '12', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('275', '4', 'forums', '12', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('271', '5', 'forums', '12', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('272', '6', 'forums', '12', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('282', '1', 'forums', '13', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('279', '2', 'forums', '13', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('280', '3', 'forums', '13', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('281', '4', 'forums', '13', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('277', '5', 'forums', '13', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('278', '6', 'forums', '13', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('288', '1', 'forums', '14', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('285', '2', 'forums', '14', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('286', '3', 'forums', '14', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('287', '4', 'forums', '14', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('283', '5', 'forums', '14', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('284', '6', 'forums', '14', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('294', '1', 'forums', '15', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('291', '2', 'forums', '15', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('292', '3', 'forums', '15', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('293', '4', 'forums', '15', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('289', '5', 'forums', '15', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('290', '6', 'forums', '15', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('300', '1', 'forums', '16', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('297', '2', 'forums', '16', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('298', '3', 'forums', '16', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('299', '4', 'forums', '16', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('295', '5', 'forums', '16', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('296', '6', 'forums', '16', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('306', '1', 'forums', '17', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('303', '2', 'forums', '17', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('304', '3', 'forums', '17', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('305', '4', 'forums', '17', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('301', '5', 'forums', '17', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('302', '6', 'forums', '17', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('312', '1', 'forums', '18', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('309', '2', 'forums', '18', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('310', '3', 'forums', '18', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('311', '4', 'forums', '18', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('307', '5', 'forums', '18', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('308', '6', 'forums', '18', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('318', '1', 'forums', '19', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('315', '2', 'forums', '19', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('316', '3', 'forums', '19', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('317', '4', 'forums', '19', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('313', '5', 'forums', '19', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('314', '6', 'forums', '19', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('324', '1', 'forums', '20', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('321', '2', 'forums', '20', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('322', '3', 'forums', '20', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('323', '4', 'forums', '20', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('319', '5', 'forums', '20', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('320', '6', 'forums', '20', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('330', '1', 'forums', '21', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('327', '2', 'forums', '21', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('328', '3', 'forums', '21', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('329', '4', 'forums', '21', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('325', '5', 'forums', '21', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('326', '6', 'forums', '21', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('336', '1', 'forums', '22', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('333', '2', 'forums', '22', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('334', '3', 'forums', '22', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('335', '4', 'forums', '22', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('331', '5', 'forums', '22', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('332', '6', 'forums', '22', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('342', '1', 'forums', '23', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('339', '2', 'forums', '23', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('340', '3', 'forums', '23', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('341', '4', 'forums', '23', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('337', '5', 'forums', '23', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('338', '6', 'forums', '23', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('180', '1', 'forums', '3', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('177', '2', 'forums', '3', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('178', '3', 'forums', '3', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('179', '4', 'forums', '3', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('175', '5', 'forums', '3', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('176', '6', 'forums', '3', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('234', '1', 'forums', '5', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('231', '2', 'forums', '5', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('232', '3', 'forums', '5', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('233', '4', 'forums', '5', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('229', '5', 'forums', '5', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('230', '6', 'forums', '5', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('240', '1', 'forums', '6', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('237', '2', 'forums', '6', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('238', '3', 'forums', '6', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('239', '4', 'forums', '6', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('235', '5', 'forums', '6', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('236', '6', 'forums', '6', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('246', '1', 'forums', '7', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('243', '2', 'forums', '7', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('244', '3', 'forums', '7', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('245', '4', 'forums', '7', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('241', '5', 'forums', '7', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('242', '6', 'forums', '7', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('252', '1', 'forums', '8', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('249', '2', 'forums', '8', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('250', '3', 'forums', '8', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('251', '4', 'forums', '8', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('247', '5', 'forums', '8', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('248', '6', 'forums', '8', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('258', '1', 'forums', '9', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('255', '2', 'forums', '9', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('256', '3', 'forums', '9', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('257', '4', 'forums', '9', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('253', '5', 'forums', '9', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('254', '6', 'forums', '9', '3', '0', '1');
INSERT INTO `sed_auth` VALUES ('11', '1', 'index', 'a', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('12', '2', 'index', 'a', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('13', '3', 'index', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('14', '4', 'index', 'a', '1', '128', '1');
INSERT INTO `sed_auth` VALUES ('15', '5', 'index', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('118', '6', 'index', 'a', '131', '0', '1');
INSERT INTO `sed_auth` VALUES ('16', '1', 'message', 'a', '1', '255', '1');
INSERT INTO `sed_auth` VALUES ('17', '2', 'message', 'a', '1', '255', '1');
INSERT INTO `sed_auth` VALUES ('18', '3', 'message', 'a', '1', '255', '1');
INSERT INTO `sed_auth` VALUES ('19', '4', 'message', 'a', '1', '255', '1');
INSERT INTO `sed_auth` VALUES ('20', '5', 'message', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('119', '6', 'message', 'a', '131', '0', '1');
INSERT INTO `sed_auth` VALUES ('56', '1', 'page', 'articles', '5', '250', '1');
INSERT INTO `sed_auth` VALUES ('57', '2', 'page', 'articles', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('58', '3', 'page', 'articles', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('59', '4', 'page', 'articles', '7', '128', '1');
INSERT INTO `sed_auth` VALUES ('60', '5', 'page', 'articles', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('127', '6', 'page', 'articles', '135', '0', '1');
INSERT INTO `sed_auth` VALUES ('61', '1', 'page', 'events', '5', '250', '1');
INSERT INTO `sed_auth` VALUES ('62', '2', 'page', 'events', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('63', '3', 'page', 'events', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('64', '4', 'page', 'events', '7', '252', '1');
INSERT INTO `sed_auth` VALUES ('65', '5', 'page', 'events', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('128', '6', 'page', 'events', '135', '0', '1');
INSERT INTO `sed_auth` VALUES ('66', '1', 'page', 'links', '5', '250', '1');
INSERT INTO `sed_auth` VALUES ('67', '2', 'page', 'links', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('68', '3', 'page', 'links', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('69', '4', 'page', 'links', '7', '128', '1');
INSERT INTO `sed_auth` VALUES ('70', '5', 'page', 'links', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('129', '6', 'page', 'links', '135', '0', '1');
INSERT INTO `sed_auth` VALUES ('71', '1', 'page', 'news', '5', '250', '1');
INSERT INTO `sed_auth` VALUES ('72', '2', 'page', 'news', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('73', '3', 'page', 'news', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('74', '4', 'page', 'news', '7', '252', '1');
INSERT INTO `sed_auth` VALUES ('75', '5', 'page', 'news', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('130', '6', 'page', 'news', '135', '0', '1');
INSERT INTO `sed_auth` VALUES ('198', '1', 'page', 'test', '5', '250', '1');
INSERT INTO `sed_auth` VALUES ('195', '2', 'page', 'test', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('196', '3', 'page', 'test', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('197', '4', 'page', 'test', '7', '128', '1');
INSERT INTO `sed_auth` VALUES ('193', '5', 'page', 'test', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('194', '6', 'page', 'test', '7', '0', '1');
INSERT INTO `sed_auth` VALUES ('204', '1', 'page', 'test2', '5', '250', '1');
INSERT INTO `sed_auth` VALUES ('201', '2', 'page', 'test2', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('202', '3', 'page', 'test2', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('203', '4', 'page', 'test2', '7', '128', '1');
INSERT INTO `sed_auth` VALUES ('199', '5', 'page', 'test2', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('200', '6', 'page', 'test2', '7', '0', '1');
INSERT INTO `sed_auth` VALUES ('210', '1', 'page', 'test3', '5', '250', '1');
INSERT INTO `sed_auth` VALUES ('207', '2', 'page', 'test3', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('208', '3', 'page', 'test3', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('209', '4', 'page', 'test3', '7', '128', '1');
INSERT INTO `sed_auth` VALUES ('205', '5', 'page', 'test3', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('206', '6', 'page', 'test3', '7', '0', '1');
INSERT INTO `sed_auth` VALUES ('21', '1', 'pfs', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('22', '2', 'pfs', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('23', '3', 'pfs', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('24', '4', 'pfs', 'a', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('25', '5', 'pfs', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('120', '6', 'pfs', 'a', '131', '0', '1');
INSERT INTO `sed_auth` VALUES ('76', '1', 'plug', 'adminqv', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('77', '2', 'plug', 'adminqv', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('78', '3', 'plug', 'adminqv', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('79', '4', 'plug', 'adminqv', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('80', '5', 'plug', 'adminqv', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('131', '6', 'plug', 'adminqv', '1', '0', '1');
INSERT INTO `sed_auth` VALUES ('81', '1', 'plug', 'cleaner', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('82', '2', 'plug', 'cleaner', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('83', '3', 'plug', 'cleaner', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('84', '4', 'plug', 'cleaner', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('85', '5', 'plug', 'cleaner', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('132', '6', 'plug', 'cleaner', '128', '255', '1');
INSERT INTO `sed_auth` VALUES ('228', '1', 'plug', 'comedit', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('225', '2', 'plug', 'comedit', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('226', '3', 'plug', 'comedit', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('227', '4', 'plug', 'comedit', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('223', '5', 'plug', 'comedit', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('224', '6', 'plug', 'comedit', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('86', '1', 'plug', 'forumstats', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('87', '2', 'plug', 'forumstats', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('88', '3', 'plug', 'forumstats', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('89', '4', 'plug', 'forumstats', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('90', '5', 'plug', 'forumstats', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('133', '6', 'plug', 'forumstats', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('163', '1', 'plug', 'indexpolls', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('164', '2', 'plug', 'indexpolls', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('165', '3', 'plug', 'indexpolls', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('166', '4', 'plug', 'indexpolls', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('167', '5', 'plug', 'indexpolls', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('168', '6', 'plug', 'indexpolls', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('192', '1', 'plug', 'ipsearch', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('189', '2', 'plug', 'ipsearch', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('190', '3', 'plug', 'ipsearch', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('191', '4', 'plug', 'ipsearch', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('187', '5', 'plug', 'ipsearch', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('188', '6', 'plug', 'ipsearch', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('106', '1', 'plug', 'markitup', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('107', '2', 'plug', 'markitup', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('108', '3', 'plug', 'markitup', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('109', '4', 'plug', 'markitup', '3', '252', '1');
INSERT INTO `sed_auth` VALUES ('110', '5', 'plug', 'markitup', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('137', '6', 'plug', 'markitup', '3', '252', '1');
INSERT INTO `sed_auth` VALUES ('222', '1', 'plug', 'massmovetopics', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('219', '2', 'plug', 'massmovetopics', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('220', '3', 'plug', 'massmovetopics', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('221', '4', 'plug', 'massmovetopics', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('217', '5', 'plug', 'massmovetopics', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('218', '6', 'plug', 'massmovetopics', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('216', '1', 'plug', 'newpagesbypath', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('213', '2', 'plug', 'newpagesbypath', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('214', '3', 'plug', 'newpagesbypath', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('215', '4', 'plug', 'newpagesbypath', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('211', '5', 'plug', 'newpagesbypath', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('212', '6', 'plug', 'newpagesbypath', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('96', '1', 'plug', 'passrecover', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('97', '2', 'plug', 'passrecover', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('98', '3', 'plug', 'passrecover', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('99', '4', 'plug', 'passrecover', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('100', '5', 'plug', 'passrecover', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('135', '6', 'plug', 'passrecover', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('145', '1', 'plug', 'recentitems', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('146', '2', 'plug', 'recentitems', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('147', '3', 'plug', 'recentitems', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('148', '4', 'plug', 'recentitems', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('149', '5', 'plug', 'recentitems', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('150', '6', 'plug', 'recentitems', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('101', '1', 'plug', 'search', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('102', '2', 'plug', 'search', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('103', '3', 'plug', 'search', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('104', '4', 'plug', 'search', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('105', '5', 'plug', 'search', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('136', '6', 'plug', 'search', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('151', '1', 'plug', 'statistics', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('152', '2', 'plug', 'statistics', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('153', '3', 'plug', 'statistics', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('154', '4', 'plug', 'statistics', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('155', '5', 'plug', 'statistics', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('156', '6', 'plug', 'statistics', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('174', '1', 'plug', 'tags', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('171', '2', 'plug', 'tags', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('172', '3', 'plug', 'tags', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('173', '4', 'plug', 'tags', '3', '124', '1');
INSERT INTO `sed_auth` VALUES ('169', '5', 'plug', 'tags', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('170', '6', 'plug', 'tags', '3', '124', '1');
INSERT INTO `sed_auth` VALUES ('111', '1', 'plug', 'whosonline', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('112', '2', 'plug', 'whosonline', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('113', '3', 'plug', 'whosonline', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('114', '4', 'plug', 'whosonline', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('115', '5', 'plug', 'whosonline', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('138', '6', 'plug', 'whosonline', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('26', '1', 'pm', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('27', '2', 'pm', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('28', '3', 'pm', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('29', '4', 'pm', 'a', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('30', '5', 'pm', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('121', '6', 'pm', 'a', '131', '0', '1');
INSERT INTO `sed_auth` VALUES ('31', '1', 'polls', 'a', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('32', '2', 'polls', 'a', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('33', '3', 'polls', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('34', '4', 'polls', 'a', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('35', '5', 'polls', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('122', '6', 'polls', 'a', '131', '0', '1');
INSERT INTO `sed_auth` VALUES ('36', '1', 'ratings', 'a', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('37', '2', 'ratings', 'a', '1', '254', '1');
INSERT INTO `sed_auth` VALUES ('38', '3', 'ratings', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('39', '4', 'ratings', 'a', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('40', '5', 'ratings', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('123', '6', 'ratings', 'a', '131', '0', '1');
INSERT INTO `sed_auth` VALUES ('41', '1', 'users', 'a', '0', '254', '1');
INSERT INTO `sed_auth` VALUES ('42', '2', 'users', 'a', '0', '254', '1');
INSERT INTO `sed_auth` VALUES ('43', '3', 'users', 'a', '0', '255', '1');
INSERT INTO `sed_auth` VALUES ('44', '4', 'users', 'a', '3', '128', '1');
INSERT INTO `sed_auth` VALUES ('45', '5', 'users', 'a', '255', '255', '1');
INSERT INTO `sed_auth` VALUES ('124', '6', 'users', 'a', '3', '0', '1');
INSERT INTO `sed_bbcode` VALUES ('65', 'b', 'str', '[b]', '<strong>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('66', 'b', 'str', '[/b]', '</strong>', '0', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('67', 'i', 'str', '[i]', '<em>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('68', 'i', 'str', '[/i]', '</em>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('69', 'u', 'str', '[u]', '<span style=\"text-decoration:underline\">', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('70', 'u', 'str', '[/u]', '</span>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('71', 's', 'str', '[s]', '<span style=\"text-decoration:line-through\">', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('72', 's', 'str', '[/s]', '</span>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('73', 'center', 'str', '[center]', '<div style=\"text-align:center\">', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('74', 'center', 'str', '[/center]', '</div>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('75', 'left', 'str', '[left]', '<div style=\"text-align:left\">', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('76', 'left', 'str', '[/left]', '</div>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('77', 'right', 'str', '[right]', '<div style=\"text-align:right\">', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('78', 'right', 'str', '[/right]', '</div>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('79', 'justify', 'str', '[justify]', '<div style=\"text-align:justify\">', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('80', 'justify', 'str', '[/justify]', '</div>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('81', 'pre', 'str', '[pre]', '<pre>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('82', 'pre', 'str', '[/pre]', '</pre>', '0', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('83', 'nbsp', 'str', '[_]', '&nbsp;', '0', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('84', 'email', 'callback', '\\[email=(\\w[\\._\\w\\-]+@[\\w\\.\\-]+\\.[a-z]+)\\](.+?)\\[/email\\]', 'return sed_obfuscate(\'<a href=\"mailto:\'.$input[1].\'\">\'.$input[2].\'</a>\');', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('85', 'quote', 'pcre', '\\[quote=(.+?)\\](.+?)\\[/quote\\]', '<blockquote><strong>$1:</strong><hr />$2</blockquote>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('86', 'quote', 'pcre', '\\[quote\\](.+?)\\[/quote\\]', '<blockquote>$1</blockquote>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('87', 'color', 'pcre', '\\[color=(#?\\w+)\\](.+?)\\[/color\\]', '<span style=\"color:$1\">$2</span>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('88', 'img', 'pcre', '\\[img\\]((?:http://|https://|ftp://)?[^\"\\\';:\\?\\[]+\\.(?:jpg|jpeg|gif|png))\\[/img\\]', '<img src=\"$1\" alt=\"\" />', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('89', 'img', 'pcre', '\\[img=((?:http://|https://|ftp://)?[^\\]\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\]((?:http://|https://|ftp://)?[^\\]\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\[/img\\]', '<a href=\"$1\"><img src=\"$2\" alt=\"\" /></a>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('90', 'url', 'pcre', '\\[url=((?:http://|https://|ftp://)?[^\\s\"\\\':\\[]+)\\](.+?)\\[/url\\]', '<a href=\"$1\">$2</a>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('91', 'url', 'pcre', '\\[url\\]((?:http://|https://|ftp://)?[^\\s\"\\\':]+)\\[/url\\]', '<a href=\"$1\">$1</a>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('92', 'code', 'callback', '\\[code\\](.+?)\\[/code\\]', 'return \'<pre class=\"code\">\'.sed_bbcode_cdata($input[1]).\'</pre>\';', '1', '1', '1', '', '0');
INSERT INTO `sed_bbcode` VALUES ('93', 'more', 'str', '[more]', '<!--more-->', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('94', 'more', 'str', '[/more]', '&nbsp;', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('95', 'size', 'pcre', '\\[size=([1-2][0-9])\\](.+?)\\[/size\\]', '<span style=\"font-size:$1pt\">$2</span>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('96', 'h', 'pcre', '\\[h([1-6])\\](.+?)\\[/h\\1\\]', '<h$1>$2</h$1>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('97', 'list', 'str', '[list]', '<ul>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('98', 'list', 'str', '[/list]', '</ul>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('99', 'ol', 'str', '[ol]', '<ol>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('100', 'ol', 'str', '[/ol]', '</ol>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('101', 'li', 'str', '[li]', '<li>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('102', 'li', 'str', '[/li]', '</li>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('103', 'li_short', 'pcre', '\\[\\*\\](.*?)\\n', '<li>$1</li>', '0', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('104', 'table', 'str', '[table]', '<table>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('105', 'table', 'str', '[/table]', '</table>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('106', 'tr', 'str', '[tr]', '<tr>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('107', 'tr', 'str', '[/tr]', '</tr>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('108', 'th', 'str', '[th]', '<th>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('109', 'th', 'str', '[/th]', '</th>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('110', 'td', 'str', '[td]', '<td>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('111', 'td', 'str', '[/td]', '</td>', '1', '1', '128', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('112', 'hide', 'callback', '\\[hide\\](.+?)\\[/hide\\]', 'return $usr[\"id\"] > 0 ? $input[1] : \"<div class=\\\"hidden\\\">\".$L[\"Hidden\"].\"</div>\";', '1', '1', '150', 'markitup', '1');
INSERT INTO `sed_bbcode` VALUES ('113', 'spoiler', 'pcre', '\\[spoiler\\](.+?)\\[/spoiler\\]', '<div style=\"margin:4px 0px 4px 0px\"><input type=\"button\" value=\"Show\" onclick=\"if(this.parentNode.getElementsByTagName(\'div\')[0].style.display != \'\') { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'\'; } else { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'none\'; }\" /><div style=\"display:none\" class=\"spoiler\">$1</div></div>', '1', '1', '130', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('114', 'spoiler', 'pcre', '\\[spoiler=([^\\]]+)\\](.+?)\\[/spoiler\\]', '<div style=\"margin:4px 0px 4px 0px\"><input type=\"button\" value=\"$1\" onclick=\"if(this.parentNode.getElementsByTagName(\'div\')[0].style.display != \'\') { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'\'; } else { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'none\'; }\" /><div style=\"display:none\" class=\"spoiler\">$2</div></div>', '1', '1', '130', 'markitup', '0');
INSERT INTO `sed_bbcode` VALUES ('115', 'thumb', 'pcre', '\\[thumb=(.*?[^\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\](.*?[^\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\[/thumb\\]', '<a href=\"datas/users/$2\"><img src=\"$1\" alt=\"$2\" /></a>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('116', 'thumb', 'pcre', '\\[thumb\\](.*?[^\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\[/thumb\\]', '<a href=\"datas/users/$1\"><img src=\"datas/thumbs/$1\" /></a>', '1', '1', '128', '', '0');
INSERT INTO `sed_bbcode` VALUES ('117', 'pfs', 'pcre', '\\[pfs\\](.*?[^\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png|zip|rar|7z|pdf|txt))\\[/pfs\\]', '<strong><a href=\"datas/users/$1\">$1</a></strong>', '1', '1', '128', '', '0');
INSERT INTO `sed_cache` VALUES ('update_info', '1255200146', '0', 'a:3:{s:10:\"update_rev\";s:3:\"976\";s:10:\"update_ver\";s:5:\"0.6.3\";s:14:\"update_message\";s:111:\"Cotonti Version 0.6.3 is avaliable\n[url=http://www.cotonti.com/downloads/releases/genoa_063]Download Now![/url]\";}');
INSERT INTO `sed_cache` VALUES ('sed_smilies', '1255129038', '1', 'a:16:{i:0;a:2:{s:4:\"code\";s:3:\":))\";s:4:\"file\";s:9:\"happy.gif\";}i:1;a:2:{s:4:\"code\";s:3:\">:)\";s:4:\"file\";s:9:\"devil.gif\";}i:2;a:2:{s:4:\"code\";s:4:\"@};-\";s:4:\"file\";s:8:\"rose.gif\";}i:3;a:2:{s:4:\"code\";s:4:\"O:-)\";s:4:\"file\";s:9:\"angel.gif\";}i:4;a:2:{s:4:\"code\";s:3:\":-*\";s:4:\"file\";s:8:\"kiss.gif\";}i:5;a:2:{s:4:\"code\";s:3:\":-X\";s:4:\"file\";s:10:\"inlove.gif\";}i:6;a:2:{s:4:\"code\";s:2:\":/\";s:4:\"file\";s:12:\"confused.gif\";}i:7;a:2:{s:4:\"code\";s:2:\":D\";s:4:\"file\";s:8:\"grin.gif\";}i:8;a:2:{s:4:\"code\";s:2:\":O\";s:4:\"file\";s:13:\"surprised.gif\";}i:9;a:2:{s:4:\"code\";s:2:\":P\";s:4:\"file\";s:10:\"tongue.gif\";}i:10;a:2:{s:4:\"code\";s:2:\";)\";s:4:\"file\";s:8:\"wink.gif\";}i:11;a:2:{s:4:\"code\";s:2:\"B)\";s:4:\"file\";s:14:\"sunglasses.gif\";}i:12;a:2:{s:4:\"code\";s:3:\"I-)\";s:4:\"file\";s:12:\"sleeping.gif\";}i:13;a:2:{s:4:\"code\";s:3:\"X-(\";s:4:\"file\";s:9:\"angry.gif\";}i:14;a:2:{s:4:\"code\";s:2:\":(\";s:4:\"file\";s:7:\"sad.gif\";}i:15;a:2:{s:4:\"code\";s:2:\":)\";s:4:\"file\";s:9:\"smile.gif\";}}');
INSERT INTO `sed_cache` VALUES ('sed_bbcodes', '1255129038', '1', 'a:52:{i:0;a:10:{s:2:\"id\";s:2:\"92\";s:4:\"name\";s:4:\"code\";s:4:\"mode\";s:8:\"callback\";s:7:\"pattern\";s:22:\"\\[code\\](.+?)\\[/code\\]\";s:11:\"replacement\";s:65:\"return \'<pre class=\"code\">\'.sed_bbcode_cdata($input[1]).\'</pre>\';\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:1:\"1\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:1;a:10:{s:2:\"id\";s:2:\"65\";s:4:\"name\";s:1:\"b\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:3:\"[b]\";s:11:\"replacement\";s:8:\"<strong>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:2;a:10:{s:2:\"id\";s:2:\"66\";s:4:\"name\";s:1:\"b\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[/b]\";s:11:\"replacement\";s:9:\"</strong>\";s:9:\"container\";s:1:\"0\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:3;a:10:{s:2:\"id\";s:2:\"67\";s:4:\"name\";s:1:\"i\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:3:\"[i]\";s:11:\"replacement\";s:4:\"<em>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:4;a:10:{s:2:\"id\";s:2:\"68\";s:4:\"name\";s:1:\"i\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[/i]\";s:11:\"replacement\";s:5:\"</em>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:5;a:10:{s:2:\"id\";s:2:\"69\";s:4:\"name\";s:1:\"u\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:3:\"[u]\";s:11:\"replacement\";s:40:\"<span style=\"text-decoration:underline\">\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:6;a:10:{s:2:\"id\";s:2:\"70\";s:4:\"name\";s:1:\"u\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[/u]\";s:11:\"replacement\";s:7:\"</span>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:7;a:10:{s:2:\"id\";s:2:\"71\";s:4:\"name\";s:1:\"s\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:3:\"[s]\";s:11:\"replacement\";s:43:\"<span style=\"text-decoration:line-through\">\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:8;a:10:{s:2:\"id\";s:2:\"72\";s:4:\"name\";s:1:\"s\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[/s]\";s:11:\"replacement\";s:7:\"</span>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:9;a:10:{s:2:\"id\";s:2:\"73\";s:4:\"name\";s:6:\"center\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:8:\"[center]\";s:11:\"replacement\";s:31:\"<div style=\"text-align:center\">\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:10;a:10:{s:2:\"id\";s:2:\"74\";s:4:\"name\";s:6:\"center\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:9:\"[/center]\";s:11:\"replacement\";s:6:\"</div>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:11;a:10:{s:2:\"id\";s:2:\"75\";s:4:\"name\";s:4:\"left\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:6:\"[left]\";s:11:\"replacement\";s:29:\"<div style=\"text-align:left\">\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:12;a:10:{s:2:\"id\";s:2:\"76\";s:4:\"name\";s:4:\"left\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:7:\"[/left]\";s:11:\"replacement\";s:6:\"</div>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:13;a:10:{s:2:\"id\";s:2:\"77\";s:4:\"name\";s:5:\"right\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:7:\"[right]\";s:11:\"replacement\";s:30:\"<div style=\"text-align:right\">\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:14;a:10:{s:2:\"id\";s:2:\"78\";s:4:\"name\";s:5:\"right\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:8:\"[/right]\";s:11:\"replacement\";s:6:\"</div>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:15;a:10:{s:2:\"id\";s:2:\"79\";s:4:\"name\";s:7:\"justify\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:9:\"[justify]\";s:11:\"replacement\";s:32:\"<div style=\"text-align:justify\">\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:16;a:10:{s:2:\"id\";s:2:\"80\";s:4:\"name\";s:7:\"justify\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:10:\"[/justify]\";s:11:\"replacement\";s:6:\"</div>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:17;a:10:{s:2:\"id\";s:2:\"81\";s:4:\"name\";s:3:\"pre\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:5:\"[pre]\";s:11:\"replacement\";s:5:\"<pre>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:18;a:10:{s:2:\"id\";s:2:\"82\";s:4:\"name\";s:3:\"pre\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:6:\"[/pre]\";s:11:\"replacement\";s:6:\"</pre>\";s:9:\"container\";s:1:\"0\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:19;a:10:{s:2:\"id\";s:2:\"83\";s:4:\"name\";s:4:\"nbsp\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:3:\"[_]\";s:11:\"replacement\";s:6:\"&nbsp;\";s:9:\"container\";s:1:\"0\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:20;a:10:{s:2:\"id\";s:2:\"84\";s:4:\"name\";s:5:\"email\";s:4:\"mode\";s:8:\"callback\";s:7:\"pattern\";s:57:\"\\[email=(\\w[\\._\\w\\-]+@[\\w\\.\\-]+\\.[a-z]+)\\](.+?)\\[/email\\]\";s:11:\"replacement\";s:73:\"return sed_obfuscate(\'<a href=\"mailto:\'.$input[1].\'\">\'.$input[2].\'</a>\');\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:21;a:10:{s:2:\"id\";s:2:\"85\";s:4:\"name\";s:5:\"quote\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:30:\"\\[quote=(.+?)\\](.+?)\\[/quote\\]\";s:11:\"replacement\";s:53:\"<blockquote><strong>$1:</strong><hr />$2</blockquote>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:22;a:10:{s:2:\"id\";s:2:\"86\";s:4:\"name\";s:5:\"quote\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:24:\"\\[quote\\](.+?)\\[/quote\\]\";s:11:\"replacement\";s:27:\"<blockquote>$1</blockquote>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:23;a:10:{s:2:\"id\";s:2:\"87\";s:4:\"name\";s:5:\"color\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:32:\"\\[color=(#?\\w+)\\](.+?)\\[/color\\]\";s:11:\"replacement\";s:32:\"<span style=\"color:$1\">$2</span>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:24;a:10:{s:2:\"id\";s:2:\"88\";s:4:\"name\";s:3:\"img\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:80:\"\\[img\\]((?:http://|https://|ftp://)?[^\"\\\';:\\?\\[]+\\.(?:jpg|jpeg|gif|png))\\[/img\\]\";s:11:\"replacement\";s:23:\"<img src=\"$1\" alt=\"\" />\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:25;a:10:{s:2:\"id\";s:2:\"89\";s:4:\"name\";s:3:\"img\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:146:\"\\[img=((?:http://|https://|ftp://)?[^\\]\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\]((?:http://|https://|ftp://)?[^\\]\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\[/img\\]\";s:11:\"replacement\";s:40:\"<a href=\"$1\"><img src=\"$2\" alt=\"\" /></a>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:26;a:10:{s:2:\"id\";s:2:\"90\";s:4:\"name\";s:3:\"url\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:63:\"\\[url=((?:http://|https://|ftp://)?[^\\s\"\\\':\\[]+)\\](.+?)\\[/url\\]\";s:11:\"replacement\";s:19:\"<a href=\"$1\">$2</a>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:27;a:10:{s:2:\"id\";s:2:\"91\";s:4:\"name\";s:3:\"url\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:55:\"\\[url\\]((?:http://|https://|ftp://)?[^\\s\"\\\':]+)\\[/url\\]\";s:11:\"replacement\";s:19:\"<a href=\"$1\">$1</a>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:28;a:10:{s:2:\"id\";s:2:\"93\";s:4:\"name\";s:4:\"more\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:6:\"[more]\";s:11:\"replacement\";s:11:\"<!--more-->\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:29;a:10:{s:2:\"id\";s:2:\"94\";s:4:\"name\";s:4:\"more\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:7:\"[/more]\";s:11:\"replacement\";s:6:\"&nbsp;\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:30;a:10:{s:2:\"id\";s:2:\"95\";s:4:\"name\";s:4:\"size\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:35:\"\\[size=([1-2][0-9])\\](.+?)\\[/size\\]\";s:11:\"replacement\";s:38:\"<span style=\"font-size:$1pt\">$2</span>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:31;a:10:{s:2:\"id\";s:2:\"96\";s:4:\"name\";s:1:\"h\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:25:\"\\[h([1-6])\\](.+?)\\[/h\\1\\]\";s:11:\"replacement\";s:13:\"<h$1>$2</h$1>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:32;a:10:{s:2:\"id\";s:2:\"97\";s:4:\"name\";s:4:\"list\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:6:\"[list]\";s:11:\"replacement\";s:4:\"<ul>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:33;a:10:{s:2:\"id\";s:2:\"98\";s:4:\"name\";s:4:\"list\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:7:\"[/list]\";s:11:\"replacement\";s:5:\"</ul>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:34;a:10:{s:2:\"id\";s:2:\"99\";s:4:\"name\";s:2:\"ol\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[ol]\";s:11:\"replacement\";s:4:\"<ol>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:35;a:10:{s:2:\"id\";s:3:\"100\";s:4:\"name\";s:2:\"ol\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:5:\"[/ol]\";s:11:\"replacement\";s:5:\"</ol>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:36;a:10:{s:2:\"id\";s:3:\"101\";s:4:\"name\";s:2:\"li\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[li]\";s:11:\"replacement\";s:4:\"<li>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:37;a:10:{s:2:\"id\";s:3:\"102\";s:4:\"name\";s:2:\"li\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:5:\"[/li]\";s:11:\"replacement\";s:5:\"</li>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:38;a:10:{s:2:\"id\";s:3:\"103\";s:4:\"name\";s:8:\"li_short\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:13:\"\\[\\*\\](.*?)\\n\";s:11:\"replacement\";s:11:\"<li>$1</li>\";s:9:\"container\";s:1:\"0\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:39;a:10:{s:2:\"id\";s:3:\"104\";s:4:\"name\";s:5:\"table\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:7:\"[table]\";s:11:\"replacement\";s:7:\"<table>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:40;a:10:{s:2:\"id\";s:3:\"105\";s:4:\"name\";s:5:\"table\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:8:\"[/table]\";s:11:\"replacement\";s:8:\"</table>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:41;a:10:{s:2:\"id\";s:3:\"106\";s:4:\"name\";s:2:\"tr\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[tr]\";s:11:\"replacement\";s:4:\"<tr>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:42;a:10:{s:2:\"id\";s:3:\"107\";s:4:\"name\";s:2:\"tr\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:5:\"[/tr]\";s:11:\"replacement\";s:5:\"</tr>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:43;a:10:{s:2:\"id\";s:3:\"108\";s:4:\"name\";s:2:\"th\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[th]\";s:11:\"replacement\";s:4:\"<th>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:44;a:10:{s:2:\"id\";s:3:\"109\";s:4:\"name\";s:2:\"th\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:5:\"[/th]\";s:11:\"replacement\";s:5:\"</th>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:45;a:10:{s:2:\"id\";s:3:\"110\";s:4:\"name\";s:2:\"td\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:4:\"[td]\";s:11:\"replacement\";s:4:\"<td>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:46;a:10:{s:2:\"id\";s:3:\"111\";s:4:\"name\";s:2:\"td\";s:4:\"mode\";s:3:\"str\";s:7:\"pattern\";s:5:\"[/td]\";s:11:\"replacement\";s:5:\"</td>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:47;a:10:{s:2:\"id\";s:3:\"115\";s:4:\"name\";s:5:\"thumb\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:96:\"\\[thumb=(.*?[^\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\](.*?[^\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\[/thumb\\]\";s:11:\"replacement\";s:54:\"<a href=\"datas/users/$2\"><img src=\"$1\" alt=\"$2\" /></a>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:48;a:10:{s:2:\"id\";s:3:\"116\";s:4:\"name\";s:5:\"thumb\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:57:\"\\[thumb\\](.*?[^\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png))\\[/thumb\\]\";s:11:\"replacement\";s:58:\"<a href=\"datas/users/$1\"><img src=\"datas/thumbs/$1\" /></a>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:49;a:10:{s:2:\"id\";s:3:\"117\";s:4:\"name\";s:3:\"pfs\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:72:\"\\[pfs\\](.*?[^\"\\\';:\\?]+\\.(?:jpg|jpeg|gif|png|zip|rar|7z|pdf|txt))\\[/pfs\\]\";s:11:\"replacement\";s:48:\"<strong><a href=\"datas/users/$1\">$1</a></strong>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"128\";s:4:\"plug\";s:0:\"\";s:10:\"postrender\";s:1:\"0\";}i:50;a:10:{s:2:\"id\";s:3:\"113\";s:4:\"name\";s:7:\"spoiler\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:28:\"\\[spoiler\\](.+?)\\[/spoiler\\]\";s:11:\"replacement\";s:360:\"<div style=\"margin:4px 0px 4px 0px\"><input type=\"button\" value=\"Show\" onclick=\"if(this.parentNode.getElementsByTagName(\'div\')[0].style.display != \'\') { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'\'; } else { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'none\'; }\" /><div style=\"display:none\" class=\"spoiler\">$1</div></div>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"130\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}i:51;a:10:{s:2:\"id\";s:3:\"114\";s:4:\"name\";s:7:\"spoiler\";s:4:\"mode\";s:4:\"pcre\";s:7:\"pattern\";s:37:\"\\[spoiler=([^\\]]+)\\](.+?)\\[/spoiler\\]\";s:11:\"replacement\";s:358:\"<div style=\"margin:4px 0px 4px 0px\"><input type=\"button\" value=\"$1\" onclick=\"if(this.parentNode.getElementsByTagName(\'div\')[0].style.display != \'\') { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'\'; } else { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'none\'; }\" /><div style=\"display:none\" class=\"spoiler\">$2</div></div>\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"130\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"0\";}}');
INSERT INTO `sed_cache` VALUES ('sed_plugins', '1255131894', '1', 'a:40:{i:0;a:16:{i:0;s:1:\"1\";s:5:\"pl_id\";s:1:\"1\";i:1;s:10:\"admin.home\";s:7:\"pl_hook\";s:10:\"admin.home\";i:2;s:7:\"adminqv\";s:7:\"pl_code\";s:7:\"adminqv\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:15:\"Admin QuickView\";s:8:\"pl_title\";s:15:\"Admin QuickView\";i:5;s:7:\"adminqv\";s:7:\"pl_file\";s:7:\"adminqv\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:1;a:16:{i:0;s:1:\"2\";s:5:\"pl_id\";s:1:\"2\";i:1;s:10:\"admin.home\";s:7:\"pl_hook\";s:10:\"admin.home\";i:2;s:7:\"cleaner\";s:7:\"pl_code\";s:7:\"cleaner\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:7:\"Cleaner\";s:8:\"pl_title\";s:7:\"Cleaner\";i:5;s:7:\"cleaner\";s:7:\"pl_file\";s:7:\"cleaner\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:2;a:16:{i:0;s:2:\"41\";s:5:\"pl_id\";s:2:\"41\";i:1;s:4:\"ajax\";s:7:\"pl_hook\";s:4:\"ajax\";i:2;s:8:\"markitup\";s:7:\"pl_code\";s:8:\"markitup\";i:3;s:7:\"preview\";s:7:\"pl_part\";s:7:\"preview\";i:4;s:9:\"MarkItUp!\";s:8:\"pl_title\";s:9:\"MarkItUp!\";i:5;s:13:\"markitup.ajax\";s:7:\"pl_file\";s:13:\"markitup.ajax\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:3;a:16:{i:0;s:2:\"49\";s:5:\"pl_id\";s:2:\"49\";i:1;s:13:\"comments.loop\";s:7:\"pl_hook\";s:13:\"comments.loop\";i:2;s:7:\"comedit\";s:7:\"pl_code\";s:7:\"comedit\";i:3;s:4:\"loop\";s:7:\"pl_part\";s:4:\"loop\";i:4;s:13:\"Comments Edit\";s:8:\"pl_title\";s:13:\"Comments Edit\";i:5;s:12:\"comedit.loop\";s:7:\"pl_file\";s:12:\"comedit.loop\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:4;a:16:{i:0;s:2:\"48\";s:5:\"pl_id\";s:2:\"48\";i:1;s:24:\"comments.newcomment.tags\";s:7:\"pl_hook\";s:24:\"comments.newcomment.tags\";i:2;s:7:\"comedit\";s:7:\"pl_code\";s:7:\"comedit\";i:3;s:4:\"form\";s:7:\"pl_part\";s:4:\"form\";i:4;s:13:\"Comments Edit\";s:8:\"pl_title\";s:13:\"Comments Edit\";i:5;s:12:\"comedit.form\";s:7:\"pl_file\";s:12:\"comedit.form\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:5;a:16:{i:0;s:2:\"50\";s:5:\"pl_id\";s:2:\"50\";i:1;s:17:\"comments.send.new\";s:7:\"pl_hook\";s:17:\"comments.send.new\";i:2;s:7:\"comedit\";s:7:\"pl_code\";s:7:\"comedit\";i:3;s:3:\"new\";s:7:\"pl_part\";s:3:\"new\";i:4;s:13:\"Comments Edit\";s:8:\"pl_title\";s:13:\"Comments Edit\";i:5;s:11:\"comedit.new\";s:7:\"pl_file\";s:11:\"comedit.new\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:6;a:16:{i:0;s:2:\"37\";s:5:\"pl_id\";s:2:\"37\";i:1;s:20:\"forums.editpost.tags\";s:7:\"pl_hook\";s:20:\"forums.editpost.tags\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:20:\"forums.editpost.tags\";s:7:\"pl_part\";s:20:\"forums.editpost.tags\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:25:\"tags.forums.editpost.tags\";s:7:\"pl_file\";s:25:\"tags.forums.editpost.tags\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:7;a:16:{i:0;s:2:\"38\";s:5:\"pl_id\";s:2:\"38\";i:1;s:27:\"forums.editpost.update.done\";s:7:\"pl_hook\";s:27:\"forums.editpost.update.done\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:15:\"forums.editpost\";s:7:\"pl_part\";s:15:\"forums.editpost\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:20:\"tags.forums.editpost\";s:7:\"pl_file\";s:20:\"tags.forums.editpost\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:8;a:16:{i:0;s:2:\"36\";s:5:\"pl_id\";s:2:\"36\";i:1;s:29:\"forums.newtopic.newtopic.done\";s:7:\"pl_hook\";s:29:\"forums.newtopic.newtopic.done\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:15:\"forums.newtopic\";s:7:\"pl_part\";s:15:\"forums.newtopic\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:20:\"tags.forums.newtopic\";s:7:\"pl_file\";s:20:\"tags.forums.newtopic\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:9;a:16:{i:0;s:2:\"35\";s:5:\"pl_id\";s:2:\"35\";i:1;s:20:\"forums.newtopic.tags\";s:7:\"pl_hook\";s:20:\"forums.newtopic.tags\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:20:\"forums.newtopic.tags\";s:7:\"pl_part\";s:20:\"forums.newtopic.tags\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:25:\"tags.forums.newtopic.tags\";s:7:\"pl_file\";s:25:\"tags.forums.newtopic.tags\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:10;a:16:{i:0;s:2:\"23\";s:5:\"pl_id\";s:2:\"23\";i:1;s:18:\"forums.posts.first\";s:7:\"pl_hook\";s:18:\"forums.posts.first\";i:2;s:6:\"search\";s:7:\"pl_code\";s:6:\"search\";i:3;s:6:\"forums\";s:7:\"pl_part\";s:6:\"forums\";i:4;s:6:\"Search\";s:8:\"pl_title\";s:6:\"Search\";i:5;s:25:\"search.forums.posts.first\";s:7:\"pl_file\";s:25:\"search.forums.posts.first\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:11;a:16:{i:0;s:2:\"34\";s:5:\"pl_id\";s:2:\"34\";i:1;s:20:\"forums.sections.tags\";s:7:\"pl_hook\";s:20:\"forums.sections.tags\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:6:\"forums\";s:7:\"pl_part\";s:6:\"forums\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:11:\"tags.forums\";s:7:\"pl_file\";s:11:\"tags.forums\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:12;a:16:{i:0;s:2:\"39\";s:5:\"pl_id\";s:2:\"39\";i:1;s:25:\"forums.topics.delete.done\";s:7:\"pl_hook\";s:25:\"forums.topics.delete.done\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:13:\"forums.delete\";s:7:\"pl_part\";s:13:\"forums.delete\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:18:\"tags.forums.delete\";s:7:\"pl_file\";s:18:\"tags.forums.delete\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:13;a:16:{i:0;s:2:\"33\";s:5:\"pl_id\";s:2:\"33\";i:1;s:18:\"forums.topics.loop\";s:7:\"pl_hook\";s:18:\"forums.topics.loop\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:13:\"forums.topics\";s:7:\"pl_part\";s:13:\"forums.topics\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:18:\"tags.forums.topics\";s:7:\"pl_file\";s:18:\"tags.forums.topics\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:14;a:16:{i:0;s:1:\"8\";s:5:\"pl_id\";s:1:\"8\";i:1;s:11:\"header.main\";s:7:\"pl_hook\";s:11:\"header.main\";i:2;s:8:\"markitup\";s:7:\"pl_code\";s:8:\"markitup\";i:3;s:6:\"header\";s:7:\"pl_part\";s:6:\"header\";i:4;s:9:\"MarkItUp!\";s:8:\"pl_title\";s:9:\"MarkItUp!\";i:5;s:15:\"markitup.header\";s:7:\"pl_file\";s:15:\"markitup.header\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:15;a:16:{i:0;s:2:\"21\";s:5:\"pl_id\";s:2:\"21\";i:1;s:11:\"header.main\";s:7:\"pl_hook\";s:11:\"header.main\";i:2;s:6:\"search\";s:7:\"pl_code\";s:6:\"search\";i:3;s:6:\"header\";s:7:\"pl_part\";s:6:\"header\";i:4;s:6:\"Search\";s:8:\"pl_title\";s:6:\"Search\";i:5;s:13:\"search.header\";s:7:\"pl_file\";s:13:\"search.header\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:16;a:16:{i:0;s:2:\"42\";s:5:\"pl_id\";s:2:\"42\";i:1;s:11:\"header.main\";s:7:\"pl_hook\";s:11:\"header.main\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:6:\"header\";s:7:\"pl_part\";s:6:\"header\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:11:\"tags.header\";s:7:\"pl_file\";s:11:\"tags.header\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:17;a:16:{i:0;s:2:\"44\";s:5:\"pl_id\";s:2:\"44\";i:1;s:10:\"index.tags\";s:7:\"pl_hook\";s:10:\"index.tags\";i:2;s:14:\"newpagesbypath\";s:7:\"pl_code\";s:14:\"newpagesbypath\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:17:\"New pages by path\";s:8:\"pl_title\";s:17:\"New pages by path\";i:5;s:20:\"newpagesbypath.index\";s:7:\"pl_file\";s:20:\"newpagesbypath.index\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:18;a:16:{i:0;s:2:\"19\";s:5:\"pl_id\";s:2:\"19\";i:1;s:10:\"index.tags\";s:7:\"pl_hook\";s:10:\"index.tags\";i:2;s:11:\"recentitems\";s:7:\"pl_code\";s:11:\"recentitems\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:12:\"Recent items\";s:8:\"pl_title\";s:12:\"Recent items\";i:5;s:11:\"recentitems\";s:7:\"pl_file\";s:11:\"recentitems\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:19;a:16:{i:0;s:2:\"24\";s:5:\"pl_id\";s:2:\"24\";i:1;s:10:\"index.tags\";s:7:\"pl_hook\";s:10:\"index.tags\";i:2;s:10:\"indexpolls\";s:7:\"pl_code\";s:10:\"indexpolls\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:10:\"Indexpolls\";s:8:\"pl_title\";s:10:\"Indexpolls\";i:5;s:10:\"indexpolls\";s:7:\"pl_file\";s:10:\"indexpolls\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:20;a:16:{i:0;s:2:\"31\";s:5:\"pl_id\";s:2:\"31\";i:1;s:10:\"index.tags\";s:7:\"pl_hook\";s:10:\"index.tags\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:5:\"index\";s:7:\"pl_part\";s:5:\"index\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:10:\"tags.index\";s:7:\"pl_file\";s:10:\"tags.index\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:21;a:16:{i:0;s:2:\"32\";s:5:\"pl_id\";s:2:\"32\";i:1;s:9:\"list.tags\";s:7:\"pl_hook\";s:9:\"list.tags\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:4:\"list\";s:7:\"pl_part\";s:4:\"list\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:9:\"tags.list\";s:7:\"pl_file\";s:9:\"tags.list\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:22;a:16:{i:0;s:2:\"45\";s:5:\"pl_id\";s:2:\"45\";i:1;s:9:\"list.tags\";s:7:\"pl_hook\";s:9:\"list.tags\";i:2;s:14:\"newpagesbypath\";s:7:\"pl_code\";s:14:\"newpagesbypath\";i:3;s:4:\"list\";s:7:\"pl_part\";s:4:\"list\";i:4;s:17:\"New pages by path\";s:8:\"pl_title\";s:17:\"New pages by path\";i:5;s:19:\"newpagesbypath.list\";s:7:\"pl_file\";s:19:\"newpagesbypath.list\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:23;a:16:{i:0;s:2:\"30\";s:5:\"pl_id\";s:2:\"30\";i:1;s:17:\"page.add.add.done\";s:7:\"pl_hook\";s:17:\"page.add.add.done\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:8:\"page.add\";s:7:\"pl_part\";s:8:\"page.add\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:13:\"tags.page.add\";s:7:\"pl_file\";s:13:\"tags.page.add\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:24;a:16:{i:0;s:2:\"29\";s:5:\"pl_id\";s:2:\"29\";i:1;s:13:\"page.add.tags\";s:7:\"pl_hook\";s:13:\"page.add.tags\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:13:\"page.add.tags\";s:7:\"pl_part\";s:13:\"page.add.tags\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:18:\"tags.page.add.tags\";s:7:\"pl_file\";s:18:\"tags.page.add.tags\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:25;a:16:{i:0;s:2:\"28\";s:5:\"pl_id\";s:2:\"28\";i:1;s:21:\"page.edit.delete.done\";s:7:\"pl_hook\";s:21:\"page.edit.delete.done\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:11:\"page.delete\";s:7:\"pl_part\";s:11:\"page.delete\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:16:\"tags.page.delete\";s:7:\"pl_file\";s:16:\"tags.page.delete\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:26;a:16:{i:0;s:2:\"26\";s:5:\"pl_id\";s:2:\"26\";i:1;s:14:\"page.edit.tags\";s:7:\"pl_hook\";s:14:\"page.edit.tags\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:14:\"page.edit.tags\";s:7:\"pl_part\";s:14:\"page.edit.tags\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:19:\"tags.page.edit.tags\";s:7:\"pl_file\";s:19:\"tags.page.edit.tags\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:27;a:16:{i:0;s:2:\"27\";s:5:\"pl_id\";s:2:\"27\";i:1;s:21:\"page.edit.update.done\";s:7:\"pl_hook\";s:21:\"page.edit.update.done\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:9:\"page.edit\";s:7:\"pl_part\";s:9:\"page.edit\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:14:\"tags.page.edit\";s:7:\"pl_file\";s:14:\"tags.page.edit\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:28;a:16:{i:0;s:2:\"22\";s:5:\"pl_id\";s:2:\"22\";i:1;s:10:\"page.first\";s:7:\"pl_hook\";s:10:\"page.first\";i:2;s:6:\"search\";s:7:\"pl_code\";s:6:\"search\";i:3;s:4:\"page\";s:7:\"pl_part\";s:4:\"page\";i:4;s:6:\"Search\";s:8:\"pl_title\";s:6:\"Search\";i:5;s:17:\"search.page.first\";s:7:\"pl_file\";s:17:\"search.page.first\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:29;a:16:{i:0;s:2:\"25\";s:5:\"pl_id\";s:2:\"25\";i:1;s:9:\"page.tags\";s:7:\"pl_hook\";s:9:\"page.tags\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:4:\"page\";s:7:\"pl_part\";s:4:\"page\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:9:\"tags.page\";s:7:\"pl_file\";s:9:\"tags.page\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:30;a:16:{i:0;s:2:\"46\";s:5:\"pl_id\";s:2:\"46\";i:1;s:9:\"page.tags\";s:7:\"pl_hook\";s:9:\"page.tags\";i:2;s:14:\"newpagesbypath\";s:7:\"pl_code\";s:14:\"newpagesbypath\";i:3;s:4:\"page\";s:7:\"pl_part\";s:4:\"page\";i:4;s:17:\"New pages by path\";s:8:\"pl_title\";s:17:\"New pages by path\";i:5;s:19:\"newpagesbypath.page\";s:7:\"pl_file\";s:19:\"newpagesbypath.page\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:31;a:16:{i:0;s:2:\"40\";s:5:\"pl_id\";s:2:\"40\";i:1;s:10:\"standalone\";s:7:\"pl_hook\";s:10:\"standalone\";i:2;s:4:\"tags\";s:7:\"pl_code\";s:4:\"tags\";i:3;s:6:\"search\";s:7:\"pl_part\";s:6:\"search\";i:4;s:4:\"Tags\";s:8:\"pl_title\";s:4:\"Tags\";i:5;s:4:\"tags\";s:7:\"pl_file\";s:4:\"tags\";i:6;s:1:\"0\";s:8:\"pl_order\";s:1:\"0\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:32;a:16:{i:0;s:1:\"3\";s:5:\"pl_id\";s:1:\"3\";i:1;s:10:\"standalone\";s:7:\"pl_hook\";s:10:\"standalone\";i:2;s:10:\"forumstats\";s:7:\"pl_code\";s:10:\"forumstats\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:16:\"Forum statistics\";s:8:\"pl_title\";s:16:\"Forum statistics\";i:5;s:10:\"forumstats\";s:7:\"pl_file\";s:10:\"forumstats\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:33;a:16:{i:0;s:1:\"5\";s:5:\"pl_id\";s:1:\"5\";i:1;s:10:\"standalone\";s:7:\"pl_hook\";s:10:\"standalone\";i:2;s:11:\"passrecover\";s:7:\"pl_code\";s:11:\"passrecover\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:17:\"Password recovery\";s:8:\"pl_title\";s:17:\"Password recovery\";i:5;s:11:\"passrecover\";s:7:\"pl_file\";s:11:\"passrecover\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:34;a:16:{i:0;s:1:\"6\";s:5:\"pl_id\";s:1:\"6\";i:1;s:10:\"standalone\";s:7:\"pl_hook\";s:10:\"standalone\";i:2;s:6:\"search\";s:7:\"pl_code\";s:6:\"search\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:6:\"Search\";s:8:\"pl_title\";s:6:\"Search\";i:5;s:6:\"search\";s:7:\"pl_file\";s:6:\"search\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:35;a:16:{i:0;s:1:\"7\";s:5:\"pl_id\";s:1:\"7\";i:1;s:10:\"standalone\";s:7:\"pl_hook\";s:10:\"standalone\";i:2;s:10:\"statistics\";s:7:\"pl_code\";s:10:\"statistics\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:10:\"Statistics\";s:8:\"pl_title\";s:10:\"Statistics\";i:5;s:10:\"statistics\";s:7:\"pl_file\";s:10:\"statistics\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:36;a:16:{i:0;s:2:\"17\";s:5:\"pl_id\";s:2:\"17\";i:1;s:10:\"standalone\";s:7:\"pl_hook\";s:10:\"standalone\";i:2;s:10:\"whosonline\";s:7:\"pl_code\";s:10:\"whosonline\";i:3;s:4:\"main\";s:7:\"pl_part\";s:4:\"main\";i:4;s:12:\"Who\'s online\";s:8:\"pl_title\";s:12:\"Who\'s online\";i:5;s:10:\"whosonline\";s:7:\"pl_file\";s:10:\"whosonline\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:37;a:16:{i:0;s:2:\"51\";s:5:\"pl_id\";s:2:\"51\";i:1;s:10:\"standalone\";s:7:\"pl_hook\";s:10:\"standalone\";i:2;s:7:\"comedit\";s:7:\"pl_code\";s:7:\"comedit\";i:3;s:4:\"edit\";s:7:\"pl_part\";s:4:\"edit\";i:4;s:13:\"Comments Edit\";s:8:\"pl_title\";s:13:\"Comments Edit\";i:5;s:7:\"comedit\";s:7:\"pl_file\";s:7:\"comedit\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:38;a:16:{i:0;s:2:\"47\";s:5:\"pl_id\";s:2:\"47\";i:1;s:5:\"tools\";s:7:\"pl_hook\";s:5:\"tools\";i:2;s:14:\"massmovetopics\";s:7:\"pl_code\";s:14:\"massmovetopics\";i:3;s:5:\"admin\";s:7:\"pl_part\";s:5:\"admin\";i:4;s:26:\"Mass-move topics in forums\";s:8:\"pl_title\";s:26:\"Mass-move topics in forums\";i:5;s:20:\"massmovetopics.admin\";s:7:\"pl_file\";s:20:\"massmovetopics.admin\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}i:39;a:16:{i:0;s:2:\"43\";s:5:\"pl_id\";s:2:\"43\";i:1;s:5:\"tools\";s:7:\"pl_hook\";s:5:\"tools\";i:2;s:8:\"ipsearch\";s:7:\"pl_code\";s:8:\"ipsearch\";i:3;s:5:\"admin\";s:7:\"pl_part\";s:5:\"admin\";i:4;s:9:\"IP search\";s:8:\"pl_title\";s:9:\"IP search\";i:5;s:14:\"ipsearch.admin\";s:7:\"pl_file\";s:14:\"ipsearch.admin\";i:6;s:2:\"10\";s:8:\"pl_order\";s:2:\"10\";i:7;s:1:\"1\";s:9:\"pl_active\";s:1:\"1\";}}');
INSERT INTO `sed_cache` VALUES ('sed_groups', '1255131021', '1', 'a:6:{i:5;a:12:{s:2:\"id\";s:1:\"5\";s:5:\"alias\";s:14:\"administrators\";s:5:\"level\";s:2:\"99\";s:8:\"disabled\";s:1:\"0\";s:6:\"hidden\";s:1:\"0\";s:5:\"state\";N;s:5:\"title\";s:14:\"Administrators\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:11:\"pfs_maxfile\";s:3:\"256\";s:12:\"pfs_maxtotal\";s:4:\"1024\";s:7:\"ownerid\";s:1:\"1\";}i:6;a:12:{s:2:\"id\";s:1:\"6\";s:5:\"alias\";s:10:\"moderators\";s:5:\"level\";s:2:\"50\";s:8:\"disabled\";s:1:\"0\";s:6:\"hidden\";s:1:\"0\";s:5:\"state\";N;s:5:\"title\";s:10:\"Moderators\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:11:\"pfs_maxfile\";s:3:\"256\";s:12:\"pfs_maxtotal\";s:4:\"1024\";s:7:\"ownerid\";s:1:\"1\";}i:2;a:12:{s:2:\"id\";s:1:\"2\";s:5:\"alias\";s:8:\"inactive\";s:5:\"level\";s:1:\"1\";s:8:\"disabled\";s:1:\"0\";s:6:\"hidden\";s:1:\"0\";s:5:\"state\";N;s:5:\"title\";s:8:\"Inactive\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:11:\"pfs_maxfile\";s:1:\"0\";s:12:\"pfs_maxtotal\";s:1:\"0\";s:7:\"ownerid\";s:1:\"1\";}i:3;a:12:{s:2:\"id\";s:1:\"3\";s:5:\"alias\";s:6:\"banned\";s:5:\"level\";s:1:\"1\";s:8:\"disabled\";s:1:\"0\";s:6:\"hidden\";s:1:\"0\";s:5:\"state\";N;s:5:\"title\";s:6:\"Banned\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:11:\"pfs_maxfile\";s:1:\"0\";s:12:\"pfs_maxtotal\";s:1:\"0\";s:7:\"ownerid\";s:1:\"1\";}i:4;a:12:{s:2:\"id\";s:1:\"4\";s:5:\"alias\";s:7:\"members\";s:5:\"level\";s:1:\"1\";s:8:\"disabled\";s:1:\"0\";s:6:\"hidden\";s:1:\"0\";s:5:\"state\";N;s:5:\"title\";s:7:\"Members\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:11:\"pfs_maxfile\";s:1:\"0\";s:12:\"pfs_maxtotal\";s:1:\"0\";s:7:\"ownerid\";s:1:\"1\";}i:1;a:12:{s:2:\"id\";s:1:\"1\";s:5:\"alias\";s:6:\"guests\";s:5:\"level\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:6:\"hidden\";s:1:\"0\";s:5:\"state\";N;s:5:\"title\";s:6:\"Guests\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:11:\"pfs_maxfile\";s:1:\"0\";s:12:\"pfs_maxtotal\";s:1:\"0\";s:7:\"ownerid\";s:1:\"1\";}}');
INSERT INTO `sed_cache` VALUES ('sed_bbcodes_post', '1255129038', '1', 'a:1:{i:0;a:10:{s:2:\"id\";s:3:\"112\";s:4:\"name\";s:4:\"hide\";s:4:\"mode\";s:8:\"callback\";s:7:\"pattern\";s:22:\"\\[hide\\](.+?)\\[/hide\\]\";s:11:\"replacement\";s:83:\"return $usr[\"id\"] > 0 ? $input[1] : \"<div class=\\\"hidden\\\">\".$L[\"Hidden\"].\"</div>\";\";s:9:\"container\";s:1:\"1\";s:7:\"enabled\";s:1:\"1\";s:8:\"priority\";s:3:\"150\";s:4:\"plug\";s:8:\"markitup\";s:10:\"postrender\";s:1:\"1\";}}');
INSERT INTO `sed_cache` VALUES ('sed_bbcode_conta', '1255129038', '1', 's:129:\"code|b|i|u|s|center|left|right|justify|pre|email|quote|color|img|url|more|size|h|list|ol|li|table|tr|th|td|thumb|pfs|spoiler|hide\";');
INSERT INTO `sed_cache` VALUES ('sed_forums_str', '1255131021', '1', 'a:3:{s:3:\"pub\";a:8:{s:4:\"path\";s:3:\"pub\";s:5:\"tpath\";s:7:\"Cotonti\";s:5:\"rpath\";s:1:\"1\";s:3:\"tpl\";s:3:\"pub\";s:5:\"title\";s:7:\"Cotonti\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:8:\"defstate\";s:1:\"1\";}s:3:\"dsf\";a:8:{s:4:\"path\";s:3:\"dsf\";s:5:\"tpath\";s:9:\"Craftwork\";s:5:\"rpath\";s:1:\"2\";s:3:\"tpl\";s:3:\"dsf\";s:5:\"title\";s:9:\"Craftwork\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:8:\"defstate\";s:1:\"1\";}s:3:\"trd\";a:8:{s:4:\"path\";s:3:\"trd\";s:5:\"tpath\";s:8:\"National\";s:5:\"rpath\";s:1:\"3\";s:3:\"tpl\";s:3:\"trd\";s:5:\"title\";s:8:\"National\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:8:\"defstate\";s:1:\"1\";}}');
INSERT INTO `sed_cache` VALUES ('sed_cat', '1255131021', '1', 'a:7:{s:8:\"articles\";a:12:{s:4:\"path\";s:8:\"articles\";s:5:\"tpath\";s:8:\"Articles\";s:5:\"rpath\";s:1:\"1\";s:3:\"tpl\";s:8:\"articles\";s:5:\"title\";s:8:\"Articles\";s:4:\"desc\";s:291:\"Профессиональная система управления сайтами Seditio CMS - программный продукт на базе PHP и MySQL, позволяющий создавать поддерживать проекты любого уровня сложности.\";s:4:\"icon\";s:0:\"\";s:5:\"group\";s:1:\"0\";s:3:\"com\";s:1:\"1\";s:7:\"ratings\";s:1:\"1\";s:5:\"order\";s:5:\"title\";s:3:\"way\";s:3:\"asc\";}s:5:\"links\";a:12:{s:4:\"path\";s:5:\"links\";s:5:\"tpath\";s:5:\"Links\";s:5:\"rpath\";s:1:\"2\";s:3:\"tpl\";s:5:\"links\";s:5:\"title\";s:5:\"Links\";s:4:\"desc\";s:211:\"Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru\";s:4:\"icon\";s:0:\"\";s:5:\"group\";s:1:\"0\";s:3:\"com\";s:1:\"1\";s:7:\"ratings\";s:1:\"1\";s:5:\"order\";s:5:\"title\";s:3:\"way\";s:3:\"asc\";}s:6:\"events\";a:12:{s:4:\"path\";s:12:\"links.events\";s:5:\"tpath\";s:19:\"Links &rarr; Events\";s:5:\"rpath\";s:3:\"2.3\";s:3:\"tpl\";s:8:\"articles\";s:5:\"title\";s:6:\"Events\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:5:\"group\";s:1:\"0\";s:3:\"com\";s:1:\"1\";s:7:\"ratings\";s:1:\"1\";s:5:\"order\";s:4:\"date\";s:3:\"way\";s:3:\"asc\";}s:4:\"test\";a:12:{s:4:\"path\";s:10:\"links.test\";s:5:\"tpath\";s:17:\"Links &rarr; Test\";s:5:\"rpath\";s:3:\"2.5\";s:3:\"tpl\";s:4:\"test\";s:5:\"title\";s:4:\"Test\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:5:\"group\";s:1:\"0\";s:3:\"com\";s:1:\"1\";s:7:\"ratings\";s:1:\"1\";s:5:\"order\";s:5:\"title\";s:3:\"way\";s:3:\"asc\";}s:5:\"test2\";a:12:{s:4:\"path\";s:11:\"links.test2\";s:5:\"tpath\";s:18:\"Links &rarr; Test2\";s:5:\"rpath\";s:3:\"2.6\";s:3:\"tpl\";s:5:\"test2\";s:5:\"title\";s:5:\"Test2\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:5:\"group\";s:1:\"0\";s:3:\"com\";s:1:\"1\";s:7:\"ratings\";s:1:\"1\";s:5:\"order\";s:5:\"title\";s:3:\"way\";s:3:\"asc\";}s:5:\"test3\";a:12:{s:4:\"path\";s:11:\"links.test3\";s:5:\"tpath\";s:18:\"Links &rarr; Test3\";s:5:\"rpath\";s:3:\"2.7\";s:3:\"tpl\";s:5:\"test3\";s:5:\"title\";s:5:\"Test3\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:5:\"group\";s:1:\"0\";s:3:\"com\";s:1:\"1\";s:7:\"ratings\";s:1:\"1\";s:5:\"order\";s:5:\"title\";s:3:\"way\";s:3:\"asc\";}s:4:\"news\";a:12:{s:4:\"path\";s:4:\"news\";s:5:\"tpath\";s:4:\"News\";s:5:\"rpath\";s:1:\"3\";s:3:\"tpl\";s:4:\"news\";s:5:\"title\";s:4:\"News\";s:4:\"desc\";s:0:\"\";s:4:\"icon\";s:0:\"\";s:5:\"group\";s:1:\"0\";s:3:\"com\";s:1:\"1\";s:7:\"ratings\";s:1:\"1\";s:5:\"order\";s:4:\"date\";s:3:\"way\";s:4:\"desc\";}}');
INSERT INTO `sed_com` VALUES ('4', 'v1', 'admin', '1', '127.0.0.1', 'Cotonti is the name of Content Management System (CMS), but it is so flexible and easy to customize, that you may feel free to call it Content Management Framework (CMF) as well. So it is a piece of software and design to power websites.', 'Cotonti is the name of Content Management System (CMS), but it is so flexible and easy to customize, that you may feel free to call it Content Management Framework (CMF) as well. So it is a piece of software and design to power websites.', '1253796355', '0', '0');
INSERT INTO `sed_com` VALUES ('3', 'v1', 'admin', '1', '127.0.0.1', 'dfgdfg', 'dfgdfg', '1252927585', '0', '0');
INSERT INTO `sed_com` VALUES ('5', 'v1', 'admin', '1', '127.0.0.1', 'вапвапвап4334', 'вапвапвап4334', '1253796359', '0', '0');
INSERT INTO `sed_com` VALUES ('8', 'v1', 'admin', '1', '127.0.0.1', 'Cotonti is the name of Content Management System (CMS), but it is so flexible and easy to customize, that you may feel free to call it Content Management Framework (CMF) as well. So it is a piece of software and design to power websitesssdf.', 'Cotonti is the name of Content Management System (CMS), but it is so flexible and easy to customize, that you may feel free to call it Content Management Framework (CMF) as well. So it is a piece of software and design to power websitesssdf.', '1253803536', '0', '0');
INSERT INTO `sed_com` VALUES ('9', 'v1', 'admin', '1', '127.0.0.1', 'fdg', 'fdg', '1254319240', '0', '0');
INSERT INTO `sed_com` VALUES ('10', 'v1', 'admin', '1', '127.0.0.1', 'Cotonti is the name of Content Management System (CMS), but it is so flexible and easy to customize, that you may feel free to call it Content Management Framework (CMF) as well. So it is a piece of software and design to power websitesssdf.', 'Cotonti is the name of Content Management System (CMS), but it is so flexible and easy to customize, that you may feel free to call it Content Management Framework (CMF) as well. So it is a piece of software and design to power websitesssdf.', '1254320289', '0', '0');
INSERT INTO `sed_com` VALUES ('11', 'v2', 'admin', '1', '127.0.0.1', 'Test comment', 'Test comment', '1254339313', '0', '0');
INSERT INTO `sed_com` VALUES ('12', 'p7', 'admin', '1', '127.0.0.1', 'Test', 'Test', '1254665855', '0', '0');
INSERT INTO `sed_com` VALUES ('13', 'p7', 'admin', '1', '127.0.0.1', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', '1254666017', '0', '0');
INSERT INTO `sed_com` VALUES ('14', 'p7', 'admin', '1', '127.0.0.1', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', '1254666977', '0', '0');
INSERT INTO `sed_com` VALUES ('15', 'p7', 'admin', '1', '127.0.0.1', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', '1254666980', '0', '0');
INSERT INTO `sed_com` VALUES ('16', 'p7', 'admin', '1', '127.0.0.1', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', '1254666982', '0', '0');
INSERT INTO `sed_com` VALUES ('17', 'p7', 'admin', '1', '127.0.0.1', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.', '1254666984', '0', '0');
INSERT INTO `sed_config` VALUES ('core', 'title', '01', 'maintitle', '1', 'Title of your site', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '02', 'subtitle', '1', 'Subtitle', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '02', 'adminemail', '1', 'admin@mysite.com', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '05', 'clustermode', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '03', 'hostip', '1', '999.999.999.999', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '04', 'cache', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '06', 'gzip', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '07', 'devmode', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '10', 'cookiedomain', '1', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '10', 'cookiepath', '1', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '10', 'cookielifetime', '2', '5184000', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '12', 'disablehitstats', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '20', 'shieldenabled', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '20', 'shieldtadjust', '2', '100', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '20', 'shieldzhammer', '2', '25', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '30', 'jquery', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '31', 'turnajax', '3', '1', '1', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '10', 'parser_custom', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '10', 'parser_cache', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '10', 'parser_disable', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '20', 'parsebbcodeusertext', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '20', 'parsebbcodecom', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '20', 'parsebbcodeforums', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '20', 'parsebbcodepages', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '30', 'parsesmiliesusertext', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '30', 'parsesmiliescom', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '30', 'parsesmiliesforums', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'parser', '30', 'parsesmiliespages', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'time', '11', 'dateformat', '1', 'd.m.Y H:i', '', '');
INSERT INTO `sed_config` VALUES ('core', 'time', '11', 'formatmonthday', '1', 'm-d', '', '');
INSERT INTO `sed_config` VALUES ('core', 'time', '11', 'formatyearmonthday', '1', 'd.m.Y', '', '');
INSERT INTO `sed_config` VALUES ('core', 'time', '11', 'formatmonthdayhourmin', '1', 'm-d H:i', '', '');
INSERT INTO `sed_config` VALUES ('core', 'time', '11', 'servertimezone', '1', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'time', '12', 'defaulttimezone', '1', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'time', '14', 'timedout', '2', '1200', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '02', 'forcedefaultskin', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '04', 'doctypeid', '4', '4', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '06', 'charset', '4', 'UTF-8', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '08', 'metakeywords', '1', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '08', 'separator', '1', '&rarr;', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '15', 'disablesysinfos', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '15', 'keepcrbottom', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '15', 'showsqlstats', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'lang', '10', 'forcedefaultlang', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '10', 'topline', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '10', 'banner', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '10', 'bottomline', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu1', '0', '<ul>\n<li><a href=\"index.php\">Home</a></li>\n<li><a href=\"forums.php\">Forums</a></li>\n<li><a href=\"list.php?c=articles\">Articles</a></li>\n<li><a href=\"plug.php?e=search\">Search</a></li>\n</ul>', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu2', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu3', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu4', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu5', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu6', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu7', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu8', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '15', 'menu9', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext1', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext2', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext3', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext4', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext5', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext6', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext7', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext8', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'menus', '20', 'freetext9', '0', '', '', '');
INSERT INTO `sed_config` VALUES ('core', 'comments', '01', 'disable_comments', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'comments', '10', 'countcomments', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'forums', '01', 'disable_forums', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'forums', '10', 'hideprivateforums', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'forums', '10', 'hottopictrigger', '2', '20', '', '');
INSERT INTO `sed_config` VALUES ('core', 'forums', '10', 'maxtopicsperpage', '2', '5', '', '');
INSERT INTO `sed_config` VALUES ('core', 'forums', '12', 'antibumpforums', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'forums', '12', 'mergeforumposts', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'forums', '12', 'mergetimeout', '2', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '03', 'title_forum_main', '1', '{FORUM}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'page', '01', 'disable_page', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'page', '02', 'allowphp_pages', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'page', '03', 'count_admin', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'page', '05', 'maxrowsperpage', '2', '5', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '01', 'disable_pfs', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '02', 'pfsuserfolder', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_amode', '2', 'GD2', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_x', '2', '112', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_y', '2', '84', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_border', '2', '4', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_dimpriority', '2', 'Width', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_keepratio', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_jpeg_quality', '2', '85', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_colorbg', '2', '000000', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_colortext', '2', 'FFFFFF', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '10', 'th_textsize', '2', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '11', 'pfs_winclose', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'plug', '01', 'disable_plug', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pm', '01', 'disable_pm', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pm', '10', 'pm_maxsize', '2', '10000', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pm', '10', 'pm_allownotifications', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'polls', '01', 'disable_polls', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'ratings', '01', 'disable_ratings', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'trash', '01', 'trash_prunedelay', '2', '7', '', '');
INSERT INTO `sed_config` VALUES ('core', 'trash', '10', 'trash_comment', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'trash', '11', 'trash_forum', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'trash', '12', 'trash_page', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'trash', '13', 'trash_pm', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'trash', '14', 'trash_user', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '01', 'disablereg', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '03', 'disablewhosonline', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '05', 'maxusersperpage', '2', '50', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '07', 'regrequireadmin', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '10', 'regnoactivation', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '10', 'useremailchange', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '10', 'user_email_noprotection', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '11', 'usertextimg', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '12', 'av_maxsize', '2', '8000', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '12', 'av_maxx', '2', '64', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '12', 'av_maxy', '2', '64', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '12', 'usertextmax', '2', '300', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '13', 'sig_maxsize', '2', '32000', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '13', 'sig_maxx', '2', '550', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '13', 'sig_maxy', '2', '100', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '14', 'ph_maxsize', '2', '32000', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '14', 'ph_maxx', '2', '128', '', '');
INSERT INTO `sed_config` VALUES ('core', 'users', '14', 'ph_maxy', '2', '128', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '1', 'pages', '3', '1', '', 'Enable Tags for Pages');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '8', 'lim_pages', '1', '0', '', 'Limit of tags in a cloud displayed for pages, 0 is unlimited');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '7', 'limit', '1', '0', '', 'Max. tags per items, 0 is unlimited');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '6', 'order', '2', 'Frequency', 'Alphabetical,Frequency,Random', 'Cloud output order - alphabetical, descending frequency or random');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '4', 'translit', '3', '1', '', 'Transliterate Tags in URLs');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '3', 'title', '3', '1', '', 'Capitalize first latters of keywords');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '05', 'pfsnomimepass', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '04', 'pfsfilecheck', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'search', '8', 'addfields', '1', '', '', 'Additional pages fields for search, separated by commas. Example \"page_extra1,page_extra2,page_key\"');
INSERT INTO `sed_config` VALUES ('plug', 'search', '6', 'showtext_ext', '3', '1', '', 'Show text in result for extended search');
INSERT INTO `sed_config` VALUES ('plug', 'search', '7', 'searchurl', '2', 'Normal', 'Normal,Single', 'Type of forum post link to use, Single uses a Single post view, while Normal uses the traditional thread/jump-to link');
INSERT INTO `sed_config` VALUES ('plug', 'search', '5', 'showtext', '3', '1', '', 'Show text in result for general search');
INSERT INTO `sed_config` VALUES ('plug', 'search', '4', 'maxitems_ext', '2', '100', '15,30,50,80,100,150,200,300', 'Maximum results lines for extended search');
INSERT INTO `sed_config` VALUES ('plug', 'search', '1', 'maxwords', '2', '5', '3,5,8,10', 'Maximum search words');
INSERT INTO `sed_config` VALUES ('plug', 'search', '2', 'maxsigns', '2', '40', '20,30,40,50,60,70,80', 'Maximum signs in query');
INSERT INTO `sed_config` VALUES ('plug', 'search', '2', 'minsigns', '2', '3', '2,3,4,5', 'Min. signs in query');
INSERT INTO `sed_config` VALUES ('plug', 'search', '3', 'maxitems', '2', '50', '15,30,50,80,100,150,200', 'Maximum results lines for general search');
INSERT INTO `sed_config` VALUES ('core', 'page', '06', 'autovalidate', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'whosonline', '3', 'miniavatar_y', '1', '16', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'whosonline', '2', 'miniavatar_x', '1', '16', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'whosonline', '1', 'showavatars', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'markitup', '1', 'skin', '1', 'markitup', '', ' Skin of editor (plugins/markitup/skins/xxxxx)');
INSERT INTO `sed_config` VALUES ('plug', 'markitup', '2', 'autorefresh', '3', '0', '', 'Enable preview auto-refresh');
INSERT INTO `sed_config` VALUES ('plug', 'markitup', '3', 'chili', '3', '0', '', 'Enable Chili tags');
INSERT INTO `sed_config` VALUES ('plug', 'comedit', '2', 'mail', '3', '0', '0,1', 'Notify about new comments by email?');
INSERT INTO `sed_config` VALUES ('plug', 'comedit', '1', 'time', '2', '10', '1,2,3,4,5,6,7,8,9,10,15,30,60,90,120,180', 'Comments editable timeout for users, minutes');
INSERT INTO `sed_config` VALUES ('plug', 'recentitems', '1', 'maxpages', '2', '6', '0,1,2,3,4,5,6,7,8,9,10,15,20,25,30', 'Recent pages displayed');
INSERT INTO `sed_config` VALUES ('core', 'main', '07', 'maintenance', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'recentitems', '4', 'maxtopics', '2', '6', '0,1,2,3,4,5,6,7,8,9,10,15,20,25,30', 'Recent topics in forums displayed');
INSERT INTO `sed_config` VALUES ('plug', 'recentitems', '5', 'fd', '2', 'Standard', 'Standard, Parent only, Subforums with Master Forums, Just Topics', 'Topic path display');
INSERT INTO `sed_config` VALUES ('plug', 'cleaner', '1', 'userprune', '2', '2', '0,1,2,3,4,5,6,7', 'Delete the user accounts not activated within * days (0 to disable).');
INSERT INTO `sed_config` VALUES ('plug', 'cleaner', '2', 'logprune', '2', '15', '0,1,2,3,7,15,30,60', 'Delete the log entries older than * days (0 to disable).');
INSERT INTO `sed_config` VALUES ('plug', 'cleaner', '3', 'refprune', '2', '30', '0,15,30,60,120,180,365', 'Delete the referer entries older than * days (0 to disable).');
INSERT INTO `sed_config` VALUES ('plug', 'cleaner', '4', 'pmnotread', '2', '120', '0,15,30,60,120,180,365', 'Delete the private messages older than * days and not read by the recipient (0 to disable).');
INSERT INTO `sed_config` VALUES ('plug', 'cleaner', '5', 'pmnotarchived', '2', '180', '0,15,30,60,120,180,365', 'Delete the private messages older than * days and not archived (0 to disable).');
INSERT INTO `sed_config` VALUES ('plug', 'cleaner', '6', 'pmold', '2', '365', '0,15,30,60,120,180,365', 'ALL the private messages older than * days (0 to disable).');
INSERT INTO `sed_config` VALUES ('core', 'title', '04', 'title_forum_topics', '1', '{FORUM} - {SECTION}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '05', 'title_forum_posts', '1', '{FORUM} - {TITLE}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '06', 'title_forum_newtopic', '1', '{FORUM} - {SECTION}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '07', 'title_forum_editpost', '1', '{FORUM} - {SECTION}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '08', 'title_list', '1', '{TITLE}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '09', 'title_page', '1', '{TITLE}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '10', 'title_pfs', '1', '{PFS}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '11', 'title_pm_main', '1', '{PM}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '12', 'title_pm_send', '1', '{PM}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '13', 'title_users_main', '1', '{USERS}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '14', 'title_users_details', '1', '{USER} : {NAME}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '15', 'title_users_profile', '1', '{PROFILE}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '16', 'title_users_edit', '1', '{NAME}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '17', 'title_header', '1', '{MAINTITLE} - {SUBTITLE}', '', '');
INSERT INTO `sed_config` VALUES ('core', 'title', '18', 'title_header_index', '1', '{MAINTITLE} - {DESCRIPTION}', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'indexpolls', '2', 'mode', '2', 'Recent polls', 'Recent polls,Random polls', '');
INSERT INTO `sed_config` VALUES ('plug', 'indexpolls', '1', 'maxpolls', '2', '1', '0,1,2,3,4,5', '');
INSERT INTO `sed_config` VALUES ('plug', 'recentitems', '5', 'redundancy', '2', '2', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '07', 'maintenancereason', '1', 'Test', '', '');
INSERT INTO `sed_config` VALUES ('core', 'polls', '02', 'ip_id_polls', '2', 'id', '', '');
INSERT INTO `sed_config` VALUES ('core', 'polls', '04', 'del_dup_options', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'polls', '03', 'max_options_polls', '1', '100', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '03', 'pfstimename', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'skin', '03', 'homebreadcrumb', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '9', 'lim_forums', '1', '0', '', 'Limit of tags in a cloud displayed in forums, 0 is unlimited');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '2', 'forums', '3', '1', '', 'Enable Tags for Forums');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '9', 'lim_index', '1', '0', '', ' Limit of tags in a cloud displayed on index, 0 is unlimited');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '10', 'more', '3', '1', '', 'Show All Tags link in tag clouds');
INSERT INTO `sed_config` VALUES ('plug', 'tags', '12', 'index', '2', 'pages', 'pages,forums,all', 'Index page tag cloud area');
INSERT INTO `sed_config` VALUES ('core', 'comments', '03', 'expand_comments', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'ratings', '02', 'ratings_allowchange', '3', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'comments', '04', 'maxcommentsperpage', '2', '5', '', '');
INSERT INTO `sed_config` VALUES ('core', 'comments', '05', 'commentsize', '2', '0', '', '');
INSERT INTO `sed_config` VALUES ('core', 'forums', '13', 'maxpostsperpage', '2', '5', '', '');
INSERT INTO `sed_config` VALUES ('core', 'page', '05', 'maxlistsperpage', '2', '5', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pfs', '06', 'maxpfsperpage', '2', '15', '', '');
INSERT INTO `sed_config` VALUES ('core', 'pm', '11', 'maxpmperpage', '2', '5', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '29', 'redirbkonlogin', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'main', '29', 'redirbkonlogout', '3', '1', '', '');
INSERT INTO `sed_config` VALUES ('core', 'version', '01', 'revision', '0', '877', '', '');
INSERT INTO `sed_config` VALUES ('plug', 'newpagesbypath', '1', 'categories', '0', 'articles', '', 'Category codes of the parents, separated by commas');
INSERT INTO `sed_config` VALUES ('plug', 'newpagesbypath', '2', 'maxpages', '2', '5', '0,1,2,3,4,5,6,7,8,9,10,15,20,25,30,50,100,200', 'Recent pages displayed');
INSERT INTO `sed_config` VALUES ('plug', 'comedit', '3', 'markitup', '2', 'Yes', 'No,Yes', 'Use markitup?');
INSERT INTO `sed_core` VALUES ('1', 'admin', 'Administration panel', '100', '1', '1');
INSERT INTO `sed_core` VALUES ('2', 'comments', 'Comments', '100', '1', '0');
INSERT INTO `sed_core` VALUES ('3', 'forums', 'Forums', '100', '1', '0');
INSERT INTO `sed_core` VALUES ('4', 'index', 'Home page', '100', '1', '1');
INSERT INTO `sed_core` VALUES ('5', 'message', 'Messages', '100', '1', '1');
INSERT INTO `sed_core` VALUES ('6', 'page', 'Pages', '100', '1', '0');
INSERT INTO `sed_core` VALUES ('7', 'pfs', 'Personal File Space', '100', '1', '0');
INSERT INTO `sed_core` VALUES ('8', 'plug', 'Plugins', '100', '1', '0');
INSERT INTO `sed_core` VALUES ('9', 'pm', 'Private messages', '100', '1', '0');
INSERT INTO `sed_core` VALUES ('10', 'polls', 'Polls', '100', '1', '0');
INSERT INTO `sed_core` VALUES ('11', 'ratings', 'Ratings', '100', '1', '0');
INSERT INTO `sed_core` VALUES ('12', 'users', 'Users', '100', '1', '1');
INSERT INTO `sed_core` VALUES ('13', 'trash', 'Trash Can', '110', '1', '1');
INSERT INTO `sed_extra_fields` VALUES ('pages', 'extra1', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('pages', 'extra2', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('pages', 'extra3', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('pages', 'extra4', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('pages', 'extra5', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra1', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra2', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra3', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra4', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra5', 'input', '<input class=\"text\" type=\"text\" maxlength=\"255\" size=\"56\" />', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra6', 'textarea', '<textarea cols=\"80\" rows=\"6\" ></textarea>', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra7', 'textarea', '<textarea cols=\"80\" rows=\"6\" ></textarea>', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra8', 'textarea', '<textarea cols=\"80\" rows=\"6\" ></textarea>', '', '');
INSERT INTO `sed_extra_fields` VALUES ('users', 'extra9', 'textarea', '<textarea cols=\"80\" rows=\"6\" ></textarea>', '', '');
INSERT INTO `sed_forum_posts` VALUES ('1', '1', '3', '1', 'admin', '1250714124', '1254314152', 'admin', 'Now this works for echoing out text like \"Hello\" or whatever, but any image won\'t show.\r\nSo my question is, how should I go about do this ?\r\n\r\nps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.\r\n\r\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.\r\n\r\nThx in advance for any help !\r\n\r\n[b]Добавлено 8 Минут спустя:[/b]\r\n\r\nNow this works for echoing out text like \"Hello\" or whatever, but any image won\'t show.\r\nSo my question is, how should I go about do this ?\r\n\r\nps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.\r\n\r\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.\r\n\r\nThx in advance for any help !\r\n\r\n[b]Добавлено 13 секунд спустя:[/b]\r\n\r\nNow this works for echoing out text like \"Hello\" or whatever, but any image won\'t show.\r\nSo my question is, how should I go about do this ?', '127.0.0.1', 'Now this works for echoing out text like &quot;Hello&quot; or whatever, but any image won\'t show.<br />\nSo my question is, how should I go about do this ?<br />\n<br />\nps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.<br />\n<br />\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.<br />\n<br />\nThx in advance for any help !<br />\n<br />\n<strong>Добавлено 8 Минут спустя:</strong><br />\n<br />\nNow this works for echoing out text like &quot;Hello&quot; or whatever, but any image won\'t show.<br />\nSo my question is, how should I go about do this ?<br />\n<br />\nps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.<br />\n<br />\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.<br />\n<br />\nThx in advance for any help !<br />\n<br />\n<strong>Добавлено 13 секунд спустя:</strong><br />\n<br />\nNow this works for echoing out text like &quot;Hello&quot; or whatever, but any image won\'t show.<br />\nSo my question is, how should I go about do this ?');
INSERT INTO `sed_forum_posts` VALUES ('2', '2', '1', '1', 'admin', '1253518248', '1254290032', 'admin', 'By registering and becoming part of this website, you agree to all of the rules that are on this page. This page can be updated at any time, so check back periodically.\r\nThe Rules of Cotonti.com :\r\n[list=1]\r\nNo Hacking – This should go without saying, but you are not permitted to hack this website. Guessing someone else\'s password and succeeding counts as hacking. Members who hack will instantly be permanently IP banned without any warnings.\r\n\r\nNo Discrimination - You may not insult members based on their religion, race, sex, political beliefs, or whether they are gay or straight. This is worse than flaming, because it also hurts other members of the board who fall into the category you insult. Cotonti.com is a place where everyone is equal, and discrimination will NOT be tolerated!\r\n\r\nRead ALL Documentation and Search - Before posting simple questions on our forums, please make sure you have read all of the documentation. From past experiences, there are a LOT of questions that could easily be answered by either reading the documentation or by using our search function. It is not only annoying to answer the same questions over, but it also clutters up the forums and takes away the response time for other more important questions.\r\n\r\nPost In The Right Section - Before you decide to make a new topic, first make sure it has not been covered before. If you find that your subject is unique, make a new topic in the right section. We do not like having to move a thousand topics just because people weren\'t nice enough to find the right section\r\n\r\nNo Bullying - Do not pick on other members.\r\n\r\nNo Flaming – Flaming is something in which will not be tolerated. It gives both you and the website a bad reputation. It also causes threads to go off topic, and most importantly, it hurts the person being flamed. The victim may defend themselves against any accusations made to them, but may not make any additional accusations to the flamer (which also counts as flaming).\r\n\r\nNo Profanity or Obscene Content - Such content does not belong on Cotonti.com. If you see words in your post being replaced with ****, you have done something wrong. The first offense will be a warning, but all offenses after that are subject to further punishment.\r\n\r\nNo Advertising – There will be no advertising of your product or website on Cotonti.com. Our users are not allowed to use the member list to obtain Instant Messaging screen names for your advertising needs.\r\n\r\nNo Illegal Activity - You are not allowed to break the law using Cotonti.com. This can get both us and you into legal trouble. Posting links to any kind of copyrighted material in which you do not have consent to use is illegal, which is a violation of this rule.\r\n\r\nNo Topic Bumping - If a topic you created has no replies, you may not post again in it (although you may edit the post). If you made the thread because you need help with something, you may post again as long as you include additional information about your problem (the fact that you really, really want it fixed does not count as additional information). You must post this in the same thread, and you are not allowed to create more than one thread per topic.\r\n\r\nNo Posting Personal Information – Do not post any information in which you do not want the world to see. This website is accessible by everyone, so don’t put your social security number in your profile and think no one will see it.\r\n\r\nNo False/Deceptive/Misleading Information - Do not post any information in which is used to trick, deceive, or mislead somone. An example of such would be posting screenshots of information that is false that you have edited. In some cases this may result in a instant ban with no warning.\r\n\r\nAmendments:\r\n[list=1]\r\nFirst Amendment - There are no excuses for breaking the rules. It doesn\'t matter if you were angry at the time and wasn’t thinking straight. It doesn\'t matter if you were only kidding around. If you break a rule, it does the same damage, regardless of your reasons for breaking it, and you will be punished all the same.\r\n\r\nSecond Amendment - Staff abuse will not be tolerated. As a staff member, your job is to help the people, not harm them. You may only use your powers for the purposes that they have been given to you for. This means that if you abuse your powers, there is a good chance you will be demoted, and a chance will be permanently banned.\r\n\r\nThird Amendment - Harassing the administration about punishments is not allowed. The staff members of Cotonti.com are only trying to do their job, and many times they have to make difficult decisions. You also may not make threats against administrators (or other members for that matter).\r\n\r\nBreaking rules result in punishments. There are several types of punishments. Depending on how serious of a violation it is, you will be punished accordingly.\r\nPunishments:\r\n[list=1]\r\nWarning – In the case of a small offense, you may be warned. A staff member of Cotonti.com will privately message you letting you know what you do wrong. In the case of a second offense of that type, further action may be taken.\r\n\r\nTemporary Ban - This is where you are not able to post on the board for a certain period of time. Repeated offenders of minor rules will be subject to a temporary ban. Once that time has passed, you will be unbanned and will be able to post again. Anyone caught evading a temporary ban will be subject to a permanent ban.\r\n\r\nPermanent Ban – This is for serious violations, repeat offenders, and ban evaders. You will never be able to post on or view ANY parts of Cotonti.com again.', '127.0.0.1', 'By registering and becoming part of this website, you agree to all of the rules that are on this page. This page can be updated at any time, so check back periodically.<br />\nThe Rules of Cotonti.com :<br />\n[list=1]<br />\nNo Hacking – This should go without saying, but you are not permitted to hack this website. Guessing someone else\'s password and succeeding counts as hacking. Members who hack will instantly be permanently IP banned without any warnings.<br />\n<br />\nNo Discrimination - You may not insult members based on their religion, race, sex, political beliefs, or whether they are gay or straight. This is worse than flaming, because it also hurts other members of the board who fall into the category you insult. Cotonti.com is a place where everyone is equal, and discrimination will NOT be tolerated!<br />\n<br />\nRead ALL Documentation and Search - Before posting simple questions on our forums, please make sure you have read all of the documentation. From past experiences, there are a LOT of questions that could easily be answered by either reading the documentation or by using our search function. It is not only annoying to answer the same questions over, but it also clutters up the forums and takes away the response time for other more important questions.<br />\n<br />\nPost In The Right Section - Before you decide to make a new topic, first make sure it has not been covered before. If you find that your subject is unique, make a new topic in the right section. We do not like having to move a thousand topics just because people weren\'t nice enough to find the right section<br />\n<br />\nNo Bullying - Do not pick on other members.<br />\n<br />\nNo Flaming – Flaming is something in which will not be tolerated. It gives both you and the website a bad reputation. It also causes threads to go off topic, and most importantly, it hurts the person being flamed. The victim may defend themselves against any accusations made to them, but may not make any additional accusations to the flamer (which also counts as flaming).<br />\n<br />\nNo Profanity or Obscene Content - Such content does not belong on Cotonti.com. If you see words in your post being replaced with ****, you have done something wrong. The first offense will be a warning, but all offenses after that are subject to further punishment.<br />\n<br />\nNo Advertising – There will be no advertising of your product or website on Cotonti.com. Our users are not allowed to use the member list to obtain Instant Messaging screen names for your advertising needs.<br />\n<br />\nNo Illegal Activity - You are not allowed to break the law using Cotonti.com. This can get both us and you into legal trouble. Posting links to any kind of copyrighted material in which you do not have consent to use is illegal, which is a violation of this rule.<br />\n<br />\nNo Topic Bumping - If a topic you created has no replies, you may not post again in it (although you may edit the post). If you made the thread because you need help with something, you may post again as long as you include additional information about your problem (the fact that you really, really want it fixed does not count as additional information). You must post this in the same thread, and you are not allowed to create more than one thread per topic.<br />\n<br />\nNo Posting Personal Information – Do not post any information in which you do not want the world to see. This website is accessible by everyone, so don’t put your social security number in your profile and think no one will see it.<br />\n<br />\nNo False/Deceptive/Misleading Information - Do not post any information in which is used to trick, deceive, or mislead somone. An example of such would be posting screenshots of information that is false that you have edited. In some cases this may result in a instant ban with no warning.<br />\n<br />\nAmendments:<br />\n[list=1]<br />\nFirst Amendment - There are no excuses for breaking the rules. It doesn\'t matter if you were angry at the time and wasn’t thinking straight. It doesn\'t matter if you were only kidding around. If you break a rule, it does the same damage, regardless of your reasons for breaking it, and you will be punished all the same.<br />\n<br />\nSecond Amendment - Staff abuse will not be tolerated. As a staff member, your job is to help the people, not harm them. You may only use your powers for the purposes that they have been given to you for. This means that if you abuse your powers, there is a good chance you will be demoted, and a chance will be permanently banned.<br />\n<br />\nThird Amendment - Harassing the administration about punishments is not allowed. The staff members of Cotonti.com are only trying to do their job, and many times they have to make difficult decisions. You also may not make threats against administrators (or other members for that matter).<br />\n<br />\nBreaking rules result in punishments. There are several types of punishments. Depending on how serious of a violation it is, you will be punished accordingly.<br />\nPunishments:<br />\n[list=1]<br />\nWarning – In the case of a small offense, you may be warned. A staff member of Cotonti.com will privately message you letting you know what you do wrong. In the case of a second offense of that type, further action may be taken.<br />\n<br />\nTemporary Ban - This is where you are not able to post on the board for a certain period of time. Repeated offenders of minor rules will be subject to a temporary ban. Once that time has passed, you will be unbanned and will be able to post again. Anyone caught evading a temporary ban will be subject to a permanent ban.<br />\n<br />\nPermanent Ban – This is for serious violations, repeat offenders, and ban evaders. You will never be able to post on or view ANY parts of Cotonti.com again.');
INSERT INTO `sed_forum_posts` VALUES ('3', '3', '3', '1', 'admin', '1254211470', '1254295888', 'admin', 'Cron manager is a plugin to allow automated script execution.\r\n\r\nFeatures:\r\n- Set first run date/time and delay\r\n- Normal or strict mode\r\n- Multiple triggers (header, index or admin)\r\n- Log failed cron jobs\r\n- Skinnable\r\n- Localisable (includes english and dutch)\r\n\r\nInstallation:\r\n- Upload files\r\n- Install plugin in admin panel\r\n\r\nUsage:\r\n- Go to admin > tools > cron manager\r\n- Add a cron job\r\n- Jobs will automatically be executed when the trigger area is visited and the next run time is past due.\r\n- Failed cron jobs (wrong script url) are marked in the jobs overview and will be logged in the Cotonti log (admin > other > system log).\r\n\r\nNotes:\r\nThis is a PASSIVE cron manager, meaning that the script will still need to be triggered by a visitor. As a result, cron jobs may be executed later than the original set execution time. If you want your cron jobs to be executed at (roughly) the same time of day, use the Strict mode. Normal mode will result in your cron job going out of sync with the first execution time. This is fine for regular usage though.\r\nThe script URL must be a local file path, starting at the root of your Cotonti installation. You can use \'plugins/cron/inc/testcron.php\' for testing script execution.', '127.0.0.1', 'Cron manager is a plugin to allow automated script execution.<br />\n<br />\nFeatures:<br />\n- Set first run date/time and delay<br />\n- Normal or strict mode<br />\n- Multiple triggers (header, index or admin)<br />\n- Log failed cron jobs<br />\n- Skinnable<br />\n- Localisable (includes english and dutch)<br />\n<br />\nInstallation:<br />\n- Upload files<br />\n- Install plugin in admin panel<br />\n<br />\nUsage:<br />\n- Go to admin &gt; tools &gt; cron manager<br />\n- Add a cron job<br />\n- Jobs will automatically be executed when the trigger area is visited and the next run time is past due.<br />\n- Failed cron jobs (wrong script url) are marked in the jobs overview and will be logged in the Cotonti log (admin &gt; other &gt; system log).<br />\n<br />\nNotes:<br />\nThis is a PASSIVE cron manager, meaning that the script will still need to be triggered by a visitor. As a result, cron jobs may be executed later than the original set execution time. If you want your cron jobs to be executed at (roughly) the same time of day, use the Strict mode. Normal mode will result in your cron job going out of sync with the first execution time. This is fine for regular usage though.<br />\nThe script URL must be a local file path, starting at the root of your Cotonti installation. You can use \'plugins/cron/inc/testcron.php\' for testing script execution.');
INSERT INTO `sed_forum_posts` VALUES ('4', '4', '6', '1', 'admin', '1254223284', '1254223284', '', 'dfg dfg  dfg dfg dfg', '127.0.0.1', 'dfg dfg  dfg dfg dfg');
INSERT INTO `sed_forum_posts` VALUES ('5', '5', '6', '1', 'admin', '1254234313', '1254234313', '', '34dfgdfgdfg df gfg dfg dfg', '127.0.0.1', '34dfgdfgdfg df gfg dfg dfg');
INSERT INTO `sed_forum_posts` VALUES ('6', '6', '6', '1', 'admin', '1254234319', '1254234319', '', 'gfh fgh f', '127.0.0.1', 'gfh fgh f');
INSERT INTO `sed_forum_posts` VALUES ('7', '7', '6', '1', 'admin', '1254234327', '1254234327', '', 'd fg dfg d', '127.0.0.1', 'd fg dfg d');
INSERT INTO `sed_forum_posts` VALUES ('8', '8', '6', '1', 'admin', '1254234392', '1254234392', '', 'ghjghjghjghjg', '127.0.0.1', 'ghjghjghjghjg');
INSERT INTO `sed_forum_posts` VALUES ('9', '9', '1', '1', 'admin', '1254234410', '1254340416', 'admin', 'I\'m working on a very basic version of the Seditio Gallery plugin. I\'ve rewritten the whole thing and left out a lot of stuff that isn\'t really necessary for a basic image gallery. I did however add the jQuery Lightbox plugin.\r\nHere\'s some screenshots.', '127.0.0.1', 'I\'m working on a very basic version of the Seditio Gallery plugin. I\'ve rewritten the whole thing and left out a lot of stuff that isn\'t really necessary for a basic image gallery. I did however add the jQuery Lightbox plugin.<br />\nHere\'s some screenshots.');
INSERT INTO `sed_forum_posts` VALUES ('10', '1', '3', '1', 'admin', '1254290821', '1254290821', '0', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.\r\n\r\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.\r\n\r\nThx in advance for any help !', '127.0.0.1', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.<br />\n<br />\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.<br />\n<br />\nThx in advance for any help !');
INSERT INTO `sed_forum_posts` VALUES ('11', '1', '3', '1', 'admin', '1254290824', '1254290824', '0', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.\r\n\r\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.\r\n\r\nThx in advance for any help !', '127.0.0.1', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.<br />\n<br />\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.<br />\n<br />\nThx in advance for any help !');
INSERT INTO `sed_forum_posts` VALUES ('12', '1', '3', '1', 'admin', '1254290828', '1254290828', '0', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.\r\n\r\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.\r\n\r\nThx in advance for any help !', '127.0.0.1', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.<br />\n<br />\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.<br />\n<br />\nThx in advance for any help !');
INSERT INTO `sed_forum_posts` VALUES ('13', '1', '3', '1', 'admin', '1254290833', '1254290833', '0', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.\r\n\r\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.\r\n\r\nThx in advance for any help !', '127.0.0.1', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.<br />\n<br />\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.<br />\n<br />\nThx in advance for any help !');
INSERT INTO `sed_forum_posts` VALUES ('14', '1', '3', '1', 'admin', '1254290838', '1254290838', '0', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.\r\n\r\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.\r\n\r\nThx in advance for any help !', '127.0.0.1', 'ps. This can NOT be solved by preconstructing the img tag, since the output of the PHP file might just as well be a movie or flash or whatever.<br />\n<br />\nI have looked all over the net and this is how far I have gotten. Since I don\'t know Javascript / AJAX at all, I\'m stuck for now.<br />\n<br />\nThx in advance for any help !');
INSERT INTO `sed_forum_posts` VALUES ('15', '10', '1', '1', 'admin', '1254291932', '1254291932', '', 'Private topic', '127.0.0.1', 'Private topic');
INSERT INTO `sed_forum_posts` VALUES ('16', '11', '3', '1', 'admin', '1254306802', '1254306802', '', 'TestTestTest', '127.0.0.1', 'TestTestTest');
INSERT INTO `sed_forum_posts` VALUES ('17', '11', '3', '2', 'admin2', '1254306900', '1254306900', '0', 'TestTestTest', '127.0.0.1', 'TestTestTest');
INSERT INTO `sed_forum_posts` VALUES ('18', '1', '3', '2', 'admin2', '1254315003', '1254315003', '0', 'testtesttesttest', '127.0.0.1', 'testtesttesttest');
INSERT INTO `sed_forum_posts` VALUES ('19', '14', '1', '2', 'admin2', '1254345234', '1254345234', '', 'Тестирование опросов', '127.0.0.1', 'Тестирование опросов');
INSERT INTO `sed_forum_posts` VALUES ('20', '14', '1', '2', 'admin2', '1254407430', '1254407430', '0', 'Тестирование опросов', '127.0.0.1', 'Тестирование опросов');
INSERT INTO `sed_forum_posts` VALUES ('21', '14', '1', '2', 'admin2', '1254407433', '1254407433', '0', 'Тестирование опросов', '127.0.0.1', 'Тестирование опросов');
INSERT INTO `sed_forum_posts` VALUES ('22', '14', '1', '2', 'admin2', '1254407437', '1254407437', '0', 'Тестирование опросов', '127.0.0.1', 'Тестирование опросов');
INSERT INTO `sed_forum_posts` VALUES ('23', '14', '1', '2', 'admin2', '1254407441', '1254407441', '0', 'Тестирование опросов', '127.0.0.1', 'Тестирование опросов');
INSERT INTO `sed_forum_posts` VALUES ('24', '14', '1', '2', 'admin2', '1254407444', '1254407444', '0', 'Тестирование опросов', '127.0.0.1', 'Тестирование опросов');
INSERT INTO `sed_forum_posts` VALUES ('25', '14', '1', '1', 'admin', '1255007139', '1255007139', '0', 'Test', '127.0.0.1', 'Test');
INSERT INTO `sed_forum_sections` VALUES ('1', '0', '100', 'General', 'pub', 'General dicussion about Cotonti', 'images/admin/veronese/forums.png', '14', 'Опрос', '1255007139', '1', 'admin', '365', '1', '1', '1', '1', '1', '5', '0', '11', '0', '529', '0', '', '1', '1');
INSERT INTO `sed_forum_sections` VALUES ('3', '0', '101', 'Support', 'pub', 'Cotonti(core) help forum', 'images/admin/veronese/forums.png', '1', 'Construct img tag with javascript', '1254315003', '2', 'admin2', '0', '1', '1', '1', '0', '1', '3', '0', '10', '0', '366', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('5', '0', '103', 'Development', 'pub', 'Project Organization and Future', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('6', '0', '102', 'Plugins', 'pub', 'Working on non-standard Plugins', 'images/admin/veronese/forums.png', '8', 'jgjgjhghjghjghj', '1254234392', '1', 'admin', '0', '1', '1', '1', '0', '1', '5', '0', '5', '0', '40', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('7', '0', '104', 'Support', 'pub', 'Plugin related help', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '6', 'Plugins', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('8', '0', '105', 'Skins', 'pub', 'Third-party Skins', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('9', '0', '106', 'Core Labs', 'pub', 'Discussing Core Features, Projects and Tasks', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('10', '0', '107', 'Ideas', 'pub', 'New ideas discussed here', 'images/admin/forums.gif', '0', '', '0', '-1', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '9', 'Core Labs', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('11', '0', '108', 'Quick tasks', 'pub', 'Small enhancements easy to implement and no doubt', 'images/admin/forums.gif', '0', '', '0', '-1', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '9', 'Core Labs', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('12', '0', '109', 'Projects', 'pub', 'Work in progress', 'images/admin/forums.gif', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '9', 'Core Labs', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('13', '0', '110', 'Archive', 'pub', 'Completed tasks and projects reside here', 'images/admin/forums.gif', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '9', 'Core Labs', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('14', '0', '100', 'Server-side', 'dsf', 'PHP, MySQL, Apache and other server-side questions', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('15', '0', '101', 'Client-side', 'dsf', 'HTML, CSS, JavaScript, Flash and other client-side technologies', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('16', '0', '102', 'Graphics', 'dsf', 'Photoshop, FireWorks, Corel and other artwork', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('17', '0', '103', 'Jobs', 'dsf', 'Job Offers and Applications', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('18', '0', '104', 'Bazaar', 'dsf', 'Buy cheap, sell more!', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('19', '0', '100', 'Russian', 'trd', 'Discussions in Russian', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('20', '0', '101', 'Turkish', 'trd', 'Discussions in Turkish', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('21', '0', '102', 'Dutch', 'trd', 'Discussions in Dutch', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('22', '0', '103', 'Swedish', 'trd', 'Discussions in Swedish', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_sections` VALUES ('23', '0', '104', 'Deutsch', 'trd', 'Allgemeines Cotonti-Schwätzchen auf Deutsch', 'images/admin/veronese/forums.png', '0', '', '0', '0', '', '0', '1', '1', '1', '0', '1', '0', '0', '0', '0', '0', '0', '', '1', '0');
INSERT INTO `sed_forum_structure` VALUES ('1', '1', 'pub', '', 'Cotonti', '', '', '1');
INSERT INTO `sed_forum_structure` VALUES ('2', '2', 'dsf', '', 'Craftwork', '', '', '1');
INSERT INTO `sed_forum_structure` VALUES ('3', '3', 'trd', '', 'National', '', '', '1');
INSERT INTO `sed_forum_topics` VALUES ('1', '0', '0', '0', '', '3', 'Construct img tag with javascript', '', '1250714124', '1254315003', '7', '408', '2', 'admin2', '1', 'admin', '0', '0', 'Now this works for echoing out text like \\&quot;Hello\\&quot; or whatever, but any image won\\\'t show.\\r\\nSo my question is, how s');
INSERT INTO `sed_forum_topics` VALUES ('2', '0', '0', '0', '', '1', 'Forum Rules', '', '1253518248', '1253518248', '1', '40', '1', 'admin', '1', 'admin', '0', '0', 'By registering and becoming part of this website, you agree to all of the rules that are on this page. This page can be updated ');
INSERT INTO `sed_forum_topics` VALUES ('3', '0', '0', '0', '', '3', 'Cron Manager', 'dfg', '1254211470', '1254211470', '1', '6', '1', 'admin', '1', 'admin', '0', '0', 'Cron manager is a plugin to allow automated script execution.\\r\\n\\r\\nFeatures:\\r\\n- Set first run date/time and delay\\r\\n- Norma');
INSERT INTO `sed_forum_topics` VALUES ('4', '0', '0', '0', '', '6', 'dfgdfgdfgdfg', 'dfgdfg dfg df gdfg dfg', '1254223284', '1254223284', '1', '1', '1', 'admin', '1', 'admin', '0', '0', 'dfg dfg  dfg dfg dfg');
INSERT INTO `sed_forum_topics` VALUES ('5', '0', '0', '0', '', '6', 'fgdfg gg', 'dfdf gdfg dfg', '1254234313', '1254234313', '1', '1', '1', 'admin', '1', 'admin', '0', '0', '34dfgdfgdfg df gfg dfg dfg');
INSERT INTO `sed_forum_topics` VALUES ('6', '0', '0', '0', '', '6', 'fgdfg ggfg', 'dfdf gdfg dfg', '1254234319', '1254234319', '1', '23', '1', 'admin', '1', 'admin', '0', '0', 'gfh fgh f');
INSERT INTO `sed_forum_topics` VALUES ('7', '0', '0', '0', '', '6', 'fgdfg gg   d df g', 'dfdf gdfg dfg   d', '1254234327', '1254234327', '1', '2', '1', 'admin', '1', 'admin', '0', '0', 'd fg dfg d');
INSERT INTO `sed_forum_topics` VALUES ('8', '0', '0', '0', '', '6', 'jgjgjhghjghjghj', 'hjghj', '1254234392', '1254234392', '1', '1', '1', 'admin', '1', 'admin', '0', '0', 'ghjghjghjghjg');
INSERT INTO `sed_forum_topics` VALUES ('9', '0', '0', '0', '', '1', 'Work in progress: Basic gallery with jQuery Lightbox', '', '1254234410', '1254234410', '1', '120', '1', 'admin', '1', 'admin', '0', '0', 'I\\\'m working on a very basic version of the Seditio Gallery plugin. I\\\'ve rewritten the whole thing and left out a lot of stuff ');
INSERT INTO `sed_forum_topics` VALUES ('13', '0', '0', '0', '', '6', 'Work in progress: Basic gallery with jQuery Lightbox', '', '1254234410', '1254340385', '0', '0', '0', '-', '1', 'admin', '0', '9', '');
INSERT INTO `sed_forum_topics` VALUES ('10', '0', '1', '0', '', '1', 'Private topic', 'Private topic', '1254291932', '1254291932', '1', '15', '1', 'admin', '1', 'admin', '0', '0', 'Private topic');
INSERT INTO `sed_forum_topics` VALUES ('11', '0', '0', '0', '', '3', 'Test', '', '1254306802', '1254306900', '2', '77', '2', 'admin2', '1', 'admin', '0', '0', 'TestTestTest');
INSERT INTO `sed_forum_topics` VALUES ('12', '0', '0', '0', '', '1', 'Construct img tag with javascript and php', '', '1250714124', '1254311413', '0', '0', '0', '-', '1', 'admin', '0', '1', '');
INSERT INTO `sed_forum_topics` VALUES ('14', '0', '0', '0', '', '1', 'Опрос', '', '1254345234', '1255007139', '7', '240', '1', 'admin', '2', 'admin2', '0', '0', 'Тестирование опросов');
INSERT INTO `sed_groups` VALUES ('1', 'guests', '0', '0', '0', 'Guests', '', '', '0', '0', '1', '0');
INSERT INTO `sed_groups` VALUES ('2', 'inactive', '1', '0', '0', 'Inactive', '', '', '0', '0', '1', '0');
INSERT INTO `sed_groups` VALUES ('3', 'banned', '1', '0', '0', 'Banned', '', '', '0', '0', '1', '0');
INSERT INTO `sed_groups` VALUES ('4', 'members', '1', '0', '0', 'Members', '', '', '0', '0', '1', '0');
INSERT INTO `sed_groups` VALUES ('5', 'administrators', '99', '0', '0', 'Administrators', '', '', '256', '1024', '1', '1');
INSERT INTO `sed_groups` VALUES ('6', 'moderators', '50', '0', '0', 'Moderators', '', '', '256', '1024', '1', '1');
INSERT INTO `sed_groups_users` VALUES ('1', '5', '0', '', '');
INSERT INTO `sed_groups_users` VALUES ('2', '4', '0', '', '');
INSERT INTO `sed_logger` VALUES ('50', '1254292042', '127.0.0.1', 'admin', 'for', 'Resetted topic #10 - /forums.php?m=topics&a=clear&x=35F8A49B&q=10&s=1');
INSERT INTO `sed_logger` VALUES ('49', '1254292039', '127.0.0.1', 'admin', 'for', 'Resetted topic #2 - /forums.php?m=topics&a=clear&x=35F8A49B&q=2&s=1');
INSERT INTO `sed_logger` VALUES ('48', '1254292030', '127.0.0.1', 'admin', 'for', 'Locked topic #2 - /forums.php?m=topics&a=lock&x=35F8A49B&q=2&s=1');
INSERT INTO `sed_logger` VALUES ('47', '1254292019', '127.0.0.1', 'admin', 'for', 'Made topic #10 private - /forums.php?m=topics&a=private&x=35F8A49B&q=10&s=1');
INSERT INTO `sed_logger` VALUES ('46', '1254292005', '127.0.0.1', 'admin', 'for', 'Locked topic #10 - /forums.php?m=topics&a=lock&x=35F8A49B&q=10&s=1');
INSERT INTO `sed_logger` VALUES ('45', '1254243165', '127.0.0.1', 'admin', 'adm', 'Edited page #6 - /page.php?m=edit&a=update&id=6');
INSERT INTO `sed_logger` VALUES ('85', '1255115584', '127.0.0.1', 'admin', 'adm', 'Cleaner plugin deleted 1 log entries older than 15 days - /admin.php');
INSERT INTO `sed_logger` VALUES ('43', '1253967674', '127.0.0.1', '', 'sec', 'A variable type check failed, expecting P/PSW for \'rpassword\' : Пароль - /users.php?m=auth&a=check&redirect=');
INSERT INTO `sed_logger` VALUES ('44', '1253970010', '127.0.0.1', '', 'sec', 'A variable type check failed, expecting P/PSW for \'rpassword\' : Пароль - /users.php?m=auth&a=check&redirect=');
INSERT INTO `sed_logger` VALUES ('62', '1254658032', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('61', '1254656589', '127.0.0.1', 'admin', 'adm', '1 old item(s) removed from the trashcan, older than 7 days - /admin.php');
INSERT INTO `sed_logger` VALUES ('83', '1255113746', '127.0.0.1', 'admin', 'adm', 'Cleaner plugin deleted 5 log entries older than 15 days - /admin.php');
INSERT INTO `sed_logger` VALUES ('84', '1255113746', '127.0.0.1', 'admin', 'adm', '1 old item(s) removed from the trashcan, older than 7 days - /admin.php');
INSERT INTO `sed_logger` VALUES ('60', '1254656589', '127.0.0.1', 'admin', 'adm', 'Cleaner plugin deleted 3 log entries older than 15 days - /admin.php');
INSERT INTO `sed_logger` VALUES ('51', '1254292047', '127.0.0.1', 'admin', 'for', 'Locked topic #10 - /forums.php?m=topics&a=lock&x=35F8A49B&q=10&s=1');
INSERT INTO `sed_logger` VALUES ('52', '1254306879', '127.0.0.1', 'admin', 'adm', 'Edited user #2 - /users.php?m=edit&a=update&x=E644E236&id=2');
INSERT INTO `sed_logger` VALUES ('53', '1254311413', '127.0.0.1', 'admin', 'for', 'Moved topic #1 from section #1 to section #3 - /forums.php?m=topics&a=move&x=E644E236&s=1&q=1');
INSERT INTO `sed_logger` VALUES ('54', '1254318298', '127.0.0.1', 'admin', 'adm', 'Edited page #3 - /page.php?m=edit&a=update&id=3');
INSERT INTO `sed_logger` VALUES ('55', '1254320280', '127.0.0.1', 'admin', 'adm', 'Edited comment #6 - /plug.php?e=comedit&m=edit&pid=v1&cid=6&a=update&x=FB07DDD2');
INSERT INTO `sed_logger` VALUES ('56', '1254320286', '127.0.0.1', 'admin', 'adm', 'Deleted comment #6 in &quot;v1&quot; - /polls.php?id=1&ina=delete&ind=6&x=FB07DDD2');
INSERT INTO `sed_logger` VALUES ('57', '1254340385', '127.0.0.1', 'admin', 'for', 'Moved topic #9 from section #6 to section #1 - /forums.php?m=topics&a=move&x=996E33C3&s=6&q=9');
INSERT INTO `sed_logger` VALUES ('58', '1254406664', '127.0.0.1', '', 'usr', 'Log in failed, user : admin2 - /users.php?m=auth&a=check&redirect=');
INSERT INTO `sed_logger` VALUES ('59', '1254656589', '127.0.0.1', 'admin', 'adm', 'Cleaner plugin deleted 2 inactivated user account(s) - /admin.php');
INSERT INTO `sed_logger` VALUES ('63', '1254658197', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('64', '1254658427', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('65', '1254658565', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('66', '1254658823', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('67', '1254659201', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('68', '1254659225', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('69', '1254659279', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('70', '1254659300', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('71', '1254659658', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('72', '1254659678', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('73', '1254660398', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('74', '1254660431', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('75', '1254660446', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('76', '1254660819', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('77', '1254660973', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('78', '1254661007', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('79', '1254661078', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('80', '1254661105', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('81', '1254661963', '127.0.0.1', 'admin', 'adm', 'Edited page #7 - /page.php?m=edit&a=update&id=7');
INSERT INTO `sed_logger` VALUES ('82', '1254727474', '127.0.0.1', 'admin', 'adm', 'Edited page #2 - /page.php?m=edit&a=update&id=2');
INSERT INTO `sed_online` VALUES ('65', '127.0.0.1', 'admin', '1255128821', 'Home', '', '1', '0', '', '0');
INSERT INTO `sed_pages` VALUES ('2', '0', '0', 'articles', '', '', '', '', '', '', 'Как сделать собственный набор кнопок для редактора MarkItUp!', 'Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.', 'Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.', '', '1', '1250076960', '1250076900', '1281612900', '0', '', '', '14', '0.00', '0', '0', '', 'Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.');
INSERT INTO `sed_pages` VALUES ('3', '0', '0', 'articles', '234234', '', '', '', '', '', 'Плагин «Магазин»', 'Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.', '1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).\r\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).\r\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).\r\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).\r\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна....', 'Cotonti Team', '1', '1250077200', '1250077200', '1281613200', '2', 'asdasdasd.rar', '234', '18', '0.00', '0', '0', 'sdfsdfsdf', '1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).<br />\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).<br />\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).<br />\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).<br />\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна....');
INSERT INTO `sed_pages` VALUES ('4', '0', '0', 'articles', '', '', '', '', '', '', 'Userpages', 'На странице о пользователе позволяет выводить информацию об созданных этим пользователем страницах', 'sdf', '', '1', '1250797500', '1250797500', '1282333500', '0', '', '', '2', '0.00', '0', '0', '', 'sdf');
INSERT INTO `sed_pages` VALUES ('5', '0', '0', 'articles', '', '', '', '', '', '', 'Технические особенности CMS Cotonti', 'Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.', 'Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.', '', '1', '1250797500', '1250797500', '1282333500', '0', '', '', '1', '0.00', '0', '0', '', 'Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.');
INSERT INTO `sed_pages` VALUES ('6', '0', '0', 'articles', '', '', '', '', '', '', 'Thumbnailviewer', 'Хорошим тоном сейчас считается просмотр полноразмерных картинок из миниатюр когда они не открываются в новом окне, а когда они всплывают...', 'Наверно вс русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.\r\n\r\n1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).\r\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна.\r\n\r\n\r\nНаверно вс русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.\r\n\r\nНаверно вс русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.', '', '1', '1250797500', '1250797500', '1282333500', '0', '', '', '27', '0.00', '0', '0', '', 'Наверно вс русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.<br />\n<br />\n1. Подключать вручную библиотеку jQuery теперь нет нужды поскольку в настройках системы Cotonti есть опция которая подключает вышеуказанный framework. Файл loading.gif - прелоадер (анимация при загрузке изображения) так же уже включена в Cotonti(расположен в папке images и называется теперь spinner_bigger.gif).<br />\n2. Распаковываем вот этот архив в корень вашего сайта. В нем два файла thumbnailviewer.js - скрипт просмотрщика и thumbnailviewer.css - файл стиля всплывающего окна.<br />\n<br />\n<br />\nНаверно вс русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.<br />\n<br />\nНаверно вс русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru в котором описано как организован просмотр полноразмерных картинок из миниатюр не открывая в новом окне, а всплывающе над страницей.');
INSERT INTO `sed_pages` VALUES ('7', '0', '0', 'articles', '', '', '', '', '', '', 'Блоки статического контента на сайте', 'Существует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке.    После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.', 'Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.\r\n[b]Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.[/b] Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.\r\n[i]Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.[/i] Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.\r\n[code]\r\n<head>\r\n.......\r\n<link href=\"skins/sed-light/thumbnailviewer.css\" rel=\"stylesheet\" type=\"text/css\" />\r\n<script type=\"text/javascript\" src=\"js/thumbnailviewer.js\"></script>\r\n.......\r\n</head>[/code]\r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. \r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. \r\n\r\n[h1]Заголовок H1[/h1]\r\n[h2]Заголовок H2[/h2]\r\n[h3]Заголовок H3[/h3]\r\n[h4]Заголовок H4[/h4]\r\n[h5]Заголовок H5[/h5]\r\n[h6]Заголовок H6[/h6]\r\nDuis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.\r\n[quote=Автор цитаты]\r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.\r\n[/quote]\r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.\r\n[spoiler=Спойлер]Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.[/spoiler]\r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.', '', '1', '1250797560', '1250797500', '1282333500', '0', '', '', '164', '0.00', '6', '0', '', 'Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.<br />\n<strong>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.</strong> Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.<br />\n<em>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.</em> Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.<br />\n<pre class=\"code\">\n&lt;head&gt;\n.......\n&lt;link href=&quot;skins/sed-light/thumbnailviewer.css&quot; rel=&quot;stylesheet&quot; type=&quot;text/css&quot; /&gt;\n&lt;script type=&quot;text/javascript&quot; src=&quot;js/thumbnailviewer.js&quot;&gt;&lt;/script&gt;\n.......\n&lt;/head&gt;</pre>\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. <br />\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. <br />\n<br />\n<h1>Заголовок H1</h1>\n<h2>Заголовок H2</h2>\n<h3>Заголовок H3</h3>\n<h4>Заголовок H4</h4>\n<h5>Заголовок H5</h5>\n<h6>Заголовок H6</h6><br />\nDuis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.<br />\n<blockquote><strong>Автор цитаты:</strong><hr />\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.<br />\n</blockquote>\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.<br />\n<div style=\"margin:4px 0px 4px 0px\"><input type=\"button\" value=\"Спойлер\" onclick=\"if(this.parentNode.getElementsByTagName(\'div\')[0].style.display != \'\') { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'\'; } else { this.parentNode.getElementsByTagName(\'div\')[0].style.display = \'none\'; }\" /><div style=\"display:none\" class=\"spoiler\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.</div></div>\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.');
INSERT INTO `sed_pages` VALUES ('8', '0', '0', 'news', '', '', '', '', '', '', 'Cotonti Server Move', '', 'As you can see we have changed versions a bit, so that now Genoa branch is 0.6.x and Renaissance is 1.0.x. We hope it causes no confusion and lets you know we are not so far from 1.0 as it was supposed before. This release solves most problems which were found in 0.0.6 (which in fact was 0.6.0, that is why so many changes and so much confusion). Now your Cotonti site should run much smoother.', '', '1', '1254752916', '1254752880', '1286288880', '0', '', '', '0', '0.00', '0', '0', '', 'As you can see we have changed versions a bit, so that now Genoa branch is 0.6.x and Renaissance is 1.0.x. We hope it causes no confusion and lets you know we are not so far from 1.0 as it was supposed before. This release solves most problems which were found in 0.0.6 (which in fact was 0.6.0, that is why so many changes and so much confusion). Now your Cotonti site should run much smoother.');
INSERT INTO `sed_pfs` VALUES ('2', '1', '1254730227', '1_1.jpg', 'jpg', '0', '', '57992', '0');
INSERT INTO `sed_pfs_folders` VALUES ('2', '1', '1253525265', '1253525265', 'Мой каталог файлов', '', '0', '0', '0');
INSERT INTO `sed_plugins` VALUES ('1', 'admin.home', 'adminqv', 'main', 'Admin QuickView', 'adminqv', '10', '1');
INSERT INTO `sed_plugins` VALUES ('2', 'admin.home', 'cleaner', 'main', 'Cleaner', 'cleaner', '10', '1');
INSERT INTO `sed_plugins` VALUES ('3', 'standalone', 'forumstats', 'main', 'Forum statistics', 'forumstats', '10', '1');
INSERT INTO `sed_plugins` VALUES ('44', 'index.tags', 'newpagesbypath', 'main', 'New pages by path', 'newpagesbypath.index', '10', '1');
INSERT INTO `sed_plugins` VALUES ('5', 'standalone', 'passrecover', 'main', 'Password recovery', 'passrecover', '10', '1');
INSERT INTO `sed_plugins` VALUES ('6', 'standalone', 'search', 'main', 'Search', 'search', '10', '1');
INSERT INTO `sed_plugins` VALUES ('7', 'standalone', 'statistics', 'main', 'Statistics', 'statistics', '10', '1');
INSERT INTO `sed_plugins` VALUES ('8', 'header.main', 'markitup', 'header', 'MarkItUp!', 'markitup.header', '10', '1');
INSERT INTO `sed_plugins` VALUES ('17', 'standalone', 'whosonline', 'main', 'Who\'s online', 'whosonline', '10', '1');
INSERT INTO `sed_plugins` VALUES ('47', 'tools', 'massmovetopics', 'admin', 'Mass-move topics in forums', 'massmovetopics.admin', '10', '1');
INSERT INTO `sed_plugins` VALUES ('19', 'index.tags', 'recentitems', 'main', 'Recent items', 'recentitems', '10', '1');
INSERT INTO `sed_plugins` VALUES ('43', 'tools', 'ipsearch', 'admin', 'IP search', 'ipsearch.admin', '10', '1');
INSERT INTO `sed_plugins` VALUES ('21', 'header.main', 'search', 'header', 'Search', 'search.header', '10', '1');
INSERT INTO `sed_plugins` VALUES ('22', 'page.first', 'search', 'page', 'Search', 'search.page.first', '10', '1');
INSERT INTO `sed_plugins` VALUES ('23', 'forums.posts.first', 'search', 'forums', 'Search', 'search.forums.posts.first', '10', '1');
INSERT INTO `sed_plugins` VALUES ('24', 'index.tags', 'indexpolls', 'main', 'Indexpolls', 'indexpolls', '10', '1');
INSERT INTO `sed_plugins` VALUES ('25', 'page.tags', 'tags', 'page', 'Tags', 'tags.page', '10', '1');
INSERT INTO `sed_plugins` VALUES ('26', 'page.edit.tags', 'tags', 'page.edit.tags', 'Tags', 'tags.page.edit.tags', '10', '1');
INSERT INTO `sed_plugins` VALUES ('27', 'page.edit.update.done', 'tags', 'page.edit', 'Tags', 'tags.page.edit', '10', '1');
INSERT INTO `sed_plugins` VALUES ('28', 'page.edit.delete.done', 'tags', 'page.delete', 'Tags', 'tags.page.delete', '10', '1');
INSERT INTO `sed_plugins` VALUES ('29', 'page.add.tags', 'tags', 'page.add.tags', 'Tags', 'tags.page.add.tags', '10', '1');
INSERT INTO `sed_plugins` VALUES ('30', 'page.add.add.done', 'tags', 'page.add', 'Tags', 'tags.page.add', '10', '1');
INSERT INTO `sed_plugins` VALUES ('31', 'index.tags', 'tags', 'index', 'Tags', 'tags.index', '10', '1');
INSERT INTO `sed_plugins` VALUES ('32', 'list.tags', 'tags', 'list', 'Tags', 'tags.list', '10', '1');
INSERT INTO `sed_plugins` VALUES ('33', 'forums.topics.loop', 'tags', 'forums.topics', 'Tags', 'tags.forums.topics', '10', '1');
INSERT INTO `sed_plugins` VALUES ('34', 'forums.sections.tags', 'tags', 'forums', 'Tags', 'tags.forums', '10', '1');
INSERT INTO `sed_plugins` VALUES ('35', 'forums.newtopic.tags', 'tags', 'forums.newtopic.tags', 'Tags', 'tags.forums.newtopic.tags', '10', '1');
INSERT INTO `sed_plugins` VALUES ('36', 'forums.newtopic.newtopic.done', 'tags', 'forums.newtopic', 'Tags', 'tags.forums.newtopic', '10', '1');
INSERT INTO `sed_plugins` VALUES ('37', 'forums.editpost.tags', 'tags', 'forums.editpost.tags', 'Tags', 'tags.forums.editpost.tags', '10', '1');
INSERT INTO `sed_plugins` VALUES ('38', 'forums.editpost.update.done', 'tags', 'forums.editpost', 'Tags', 'tags.forums.editpost', '10', '1');
INSERT INTO `sed_plugins` VALUES ('39', 'forums.topics.delete.done', 'tags', 'forums.delete', 'Tags', 'tags.forums.delete', '10', '1');
INSERT INTO `sed_plugins` VALUES ('40', 'standalone', 'tags', 'search', 'Tags', 'tags', '0', '1');
INSERT INTO `sed_plugins` VALUES ('41', 'ajax', 'markitup', 'preview', 'MarkItUp!', 'markitup.ajax', '10', '1');
INSERT INTO `sed_plugins` VALUES ('42', 'header.main', 'tags', 'header', 'Tags', 'tags.header', '10', '1');
INSERT INTO `sed_plugins` VALUES ('45', 'list.tags', 'newpagesbypath', 'list', 'New pages by path', 'newpagesbypath.list', '10', '1');
INSERT INTO `sed_plugins` VALUES ('46', 'page.tags', 'newpagesbypath', 'page', 'New pages by path', 'newpagesbypath.page', '10', '1');
INSERT INTO `sed_plugins` VALUES ('48', 'comments.newcomment.tags', 'comedit', 'form', 'Comments Edit', 'comedit.form', '10', '1');
INSERT INTO `sed_plugins` VALUES ('49', 'comments.loop', 'comedit', 'loop', 'Comments Edit', 'comedit.loop', '10', '1');
INSERT INTO `sed_plugins` VALUES ('50', 'comments.send.new', 'comedit', 'new', 'Comments Edit', 'comedit.new', '10', '1');
INSERT INTO `sed_plugins` VALUES ('51', 'standalone', 'comedit', 'edit', 'Comments Edit', 'comedit', '10', '1');
INSERT INTO `sed_pm` VALUES ('1', '2', '1252166298', '1', 'admin', '1', 'sdf', 'sdfsdf', 'sdfsdf');
INSERT INTO `sed_pm` VALUES ('2', '3', '1252166298', '1', 'admin', '1', 'sdf', 'sdfsdf', 'sdfsdf');
INSERT INTO `sed_pm` VALUES ('3', '2', '1252169343', '1', 'admin', '1', 'Личные сообщения Новое личное сообщение', 'Личные сообщения Новое личное сообщениеЛичные сообщения Новое личное сообщение', 'Личные сообщения Новое личное сообщениеЛичные сообщения Новое личное сообщение');
INSERT INTO `sed_pm` VALUES ('4', '3', '1252169343', '1', 'admin', '1', 'Личные сообщения Новое личное сообщение', 'Личные сообщения Новое личное сообщениеЛичные сообщения Новое личное сообщение', 'Личные сообщения Новое личное сообщениеЛичные сообщения Новое личное сообщение');
INSERT INTO `sed_pm` VALUES ('7', '2', '1252247144', '1', 'admin', '1', ' . . . ', 'sdfsdfsdf', 'sdfsdfsdf');
INSERT INTO `sed_pm` VALUES ('6', '3', '1252246727', '1', 'admin', '1', '. . .', 'dfg', 'dfg');
INSERT INTO `sed_pm` VALUES ('8', '2', '1252247152', '1', 'admin', '1', ' . . . ', 'dfgdfgdfgdfg45fe', 'dfgdfgdfgdfg45fe');
INSERT INTO `sed_pm` VALUES ('9', '2', '1252247171', '1', 'admin', '1', ' . . . ', 'sdfsdfsdfsdf', 'sdfsdfsdfsdf');
INSERT INTO `sed_pm` VALUES ('10', '2', '1252247180', '1', 'admin', '1', ' . . . ', 'dfgdfgdfg45645645', 'dfgdfgdfg45645645');
INSERT INTO `sed_pm` VALUES ('11', '2', '1252247216', '1', 'admin', '1', ' . . . ', 'dfgdfgdfg', 'dfgdfgdfg');
INSERT INTO `sed_pm` VALUES ('12', '2', '1252247252', '1', 'admin', '1', ' . . . ', 'dfg3sdf4fsdfsdf', 'dfg3sdf4fsdfsdf');
INSERT INTO `sed_pm` VALUES ('13', '3', '1252247252', '1', 'admin', '1', ' . . . ', 'dfg3sdf4fsdfsdf', 'dfg3sdf4fsdfsdf');
INSERT INTO `sed_pm` VALUES ('15', '3', '1252247900', '1', 'admin', '1', ' . . . ', 'dfgdfg', 'dfgdfg');
INSERT INTO `sed_pm` VALUES ('22', '1', '1252925619', '1', 'admin', '1', 'Re:  . . .', 'dfgd', 'dfgd');
INSERT INTO `sed_pm` VALUES ('23', '1', '1252925623', '1', 'admin', '1', 'Re(4): Личные сообщения Новое личное сообщение', 'dfgdg', 'dfgdg');
INSERT INTO `sed_pm` VALUES ('17', '3', '1252263554', '1', 'admin', '1', 'Re: Личные сообщения Новое личное сообщение', '[code]dfgdfg[/code]', '<pre class=\"code\">dfgdfg</pre>');
INSERT INTO `sed_pm` VALUES ('24', '1', '1252925632', '1', 'admin', '1', 'Re(4): Личные сообщения Новое личное сообщение', 'dfg', 'dfg');
INSERT INTO `sed_pm` VALUES ('19', '3', '1252263612', '1', 'admin', '1', 'Re(2): Личные сообщения Новое личное сообщение', 'sdfsdfsdf', 'sdfsdfsdf');
INSERT INTO `sed_pm` VALUES ('25', '3', '1252925632', '1', 'admin', '1', 'Re(4): Личные сообщения Новое личное сообщение', 'dfg', 'dfg');
INSERT INTO `sed_pm` VALUES ('26', '3', '1252925619', '1', 'admin', '1', 'Re:  . . .', 'dfgd', 'dfgd');
INSERT INTO `sed_pm` VALUES ('27', '3', '1252925623', '1', 'admin', '1', 'Re(4): Личные сообщения Новое личное сообщение', 'dfgdg', 'dfgdg');
INSERT INTO `sed_pm` VALUES ('28', '0', '1255128342', '1', 'admin', '1', 'dfgdfg', '[h5][/h5]dfgdfgdfgdf', '[h5][/h5]dfgdfgdfgdf');
INSERT INTO `sed_pm` VALUES ('21', '3', '1252263676', '1', 'admin', '1', 'Re(3): Личные сообщения Новое личное сообщение', 'уществует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке. После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.уществует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке. После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.уществует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке. После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.уществует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке. После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.', 'уществует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке. После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.уществует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке. После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.уществует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке. После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.уществует плагин, который позволяет выводить контент заданной страницы в любом месте сайта. Плагин этот называется pagetextbyidn и включается в админке. После включения в tpl файлах можно использовать тэг {PAGE_TEXT_ID_xx}, которая выводит контент.');
INSERT INTO `sed_polls` VALUES ('1', 'index', '0', '0', '1253784379', 'Which PHP accelerators/cache does your host provide?', '0');
INSERT INTO `sed_polls` VALUES ('2', 'index', '0', '0', '1253622996', 'Первый или второй?', '0');
INSERT INTO `sed_polls` VALUES ('4', 'forum', '14', '0', '1254345234', 'Круто получилось?', '0');
INSERT INTO `sed_polls_options` VALUES ('1', '1', 'APC', '0');
INSERT INTO `sed_polls_options` VALUES ('2', '1', 'eAccelerator', '0');
INSERT INTO `sed_polls_options` VALUES ('3', '2', 'Первый', '0');
INSERT INTO `sed_polls_options` VALUES ('4', '2', 'Второй', '1');
INSERT INTO `sed_polls_options` VALUES ('10', '1', 'XCache', '0');
INSERT INTO `sed_polls_options` VALUES ('11', '1', 'None!', '0');
INSERT INTO `sed_polls_options` VALUES ('12', '4', 'По-моему очень', '1');
INSERT INTO `sed_polls_options` VALUES ('13', '4', 'Ниче так', '1');
INSERT INTO `sed_polls_options` VALUES ('14', '4', 'Шило', '0');
INSERT INTO `sed_polls_voters` VALUES ('20', '1', '1', '127.0.0.1');
INSERT INTO `sed_polls_voters` VALUES ('12', '2', '1', '127.0.0.1');
INSERT INTO `sed_polls_voters` VALUES ('21', '4', '1', '127.0.0.1');
INSERT INTO `sed_polls_voters` VALUES ('18', '4', '2', '127.0.0.1');
INSERT INTO `sed_rated` VALUES ('2', 'p2', '1', '9');
INSERT INTO `sed_rated` VALUES ('3', 'p6', '1', '10');
INSERT INTO `sed_rated` VALUES ('4', 'p7', '1', '9');
INSERT INTO `sed_ratings` VALUES ('2', 'p2', '0', '9.00', '1251112673', '');
INSERT INTO `sed_ratings` VALUES ('3', 'p6', '0', '10.00', '1254153880', '');
INSERT INTO `sed_ratings` VALUES ('4', 'p7', '0', '9.00', '1254657895', '');
INSERT INTO `sed_stats` VALUES ('totalpages', '18058');
INSERT INTO `sed_stats` VALUES ('totalmailsent', '4');
INSERT INTO `sed_stats` VALUES ('totalmailpmnot', '0');
INSERT INTO `sed_stats` VALUES ('totalpms', '17');
INSERT INTO `sed_stats` VALUES ('totalantihammer', '0');
INSERT INTO `sed_stats` VALUES ('textboxerprev', '0');
INSERT INTO `sed_stats` VALUES ('version', '120');
INSERT INTO `sed_stats` VALUES ('maxusers', '2');
INSERT INTO `sed_stats` VALUES ('2009-08-11', '595');
INSERT INTO `sed_stats` VALUES ('2009-08-12', '1428');
INSERT INTO `sed_stats` VALUES ('2009-08-13', '84');
INSERT INTO `sed_stats` VALUES ('2009-08-14', '160');
INSERT INTO `sed_stats` VALUES ('2009-08-15', '98');
INSERT INTO `sed_stats` VALUES ('2009-08-16', '669');
INSERT INTO `sed_stats` VALUES ('2009-08-17', '324');
INSERT INTO `sed_stats` VALUES ('2009-08-19', '178');
INSERT INTO `sed_stats` VALUES ('2009-08-20', '692');
INSERT INTO `sed_stats` VALUES ('2009-08-21', '580');
INSERT INTO `sed_stats` VALUES ('2009-08-22', '8');
INSERT INTO `sed_stats` VALUES ('2009-08-24', '471');
INSERT INTO `sed_stats` VALUES ('2009-08-25', '703');
INSERT INTO `sed_stats` VALUES ('2009-08-26', '11');
INSERT INTO `sed_stats` VALUES ('2009-08-27', '261');
INSERT INTO `sed_stats` VALUES ('2009-08-28', '203');
INSERT INTO `sed_stats` VALUES ('2009-08-31', '9');
INSERT INTO `sed_stats` VALUES ('2009-09-01', '49');
INSERT INTO `sed_stats` VALUES ('2009-09-02', '4');
INSERT INTO `sed_stats` VALUES ('2009-09-03', '1');
INSERT INTO `sed_stats` VALUES ('2009-09-04', '166');
INSERT INTO `sed_stats` VALUES ('2009-09-05', '495');
INSERT INTO `sed_stats` VALUES ('2009-09-06', '898');
INSERT INTO `sed_stats` VALUES ('2009-09-07', '188');
INSERT INTO `sed_stats` VALUES ('2009-09-08', '113');
INSERT INTO `sed_stats` VALUES ('2009-09-09', '1');
INSERT INTO `sed_stats` VALUES ('2009-09-14', '148');
INSERT INTO `sed_stats` VALUES ('2009-09-17', '92');
INSERT INTO `sed_stats` VALUES ('2009-09-18', '263');
INSERT INTO `sed_stats` VALUES ('2009-09-20', '165');
INSERT INTO `sed_stats` VALUES ('2009-09-21', '113');
INSERT INTO `sed_stats` VALUES ('2009-09-22', '197');
INSERT INTO `sed_stats` VALUES ('2009-09-24', '793');
INSERT INTO `sed_stats` VALUES ('2009-09-25', '152');
INSERT INTO `sed_stats` VALUES ('2009-09-26', '1392');
INSERT INTO `sed_stats` VALUES ('2009-09-27', '1');
INSERT INTO `sed_stats` VALUES ('2009-09-28', '665');
INSERT INTO `sed_stats` VALUES ('2009-09-29', '950');
INSERT INTO `sed_stats` VALUES ('2009-09-30', '1792');
INSERT INTO `sed_stats` VALUES ('2009-10-01', '284');
INSERT INTO `sed_stats` VALUES ('2009-10-02', '59');
INSERT INTO `sed_stats` VALUES ('2009-10-04', '979');
INSERT INTO `sed_stats` VALUES ('2009-10-05', '280');
INSERT INTO `sed_stats` VALUES ('2009-10-06', '221');
INSERT INTO `sed_stats` VALUES ('2009-10-07', '3');
INSERT INTO `sed_stats` VALUES ('2009-10-08', '518');
INSERT INTO `sed_stats` VALUES ('2009-10-09', '602');
INSERT INTO `sed_structure` VALUES ('1', 'articles', '1', '', 'Articles', 'Профессиональная система управления сайтами Seditio CMS - программный продукт на базе PHP и MySQL, позволяющий создавать поддерживать проекты любого уровня сложности.', '', '0', 'title.asc', '50', '1', '1');
INSERT INTO `sed_structure` VALUES ('2', 'links', '2', '', 'Links', 'Наверно все русскоязычны ользователи которые используют Seditio хоть раз сталкивались вот с этим документом на neocrome.ru', '', '0', 'title.asc', '0', '1', '1');
INSERT INTO `sed_structure` VALUES ('3', 'events', '2.3', 'articles', 'Events', '', '', '0', 'date.asc', '0', '1', '1');
INSERT INTO `sed_structure` VALUES ('4', 'news', '3', '', 'News', '', '', '0', 'date.desc', '1', '1', '1');
INSERT INTO `sed_structure` VALUES ('5', 'test', '2.5', '', 'Test', '', '', '0', 'title.asc', '0', '1', '1');
INSERT INTO `sed_structure` VALUES ('6', 'test2', '2.6', '', 'Test2', '', '', '0', 'title.asc', '0', '1', '1');
INSERT INTO `sed_structure` VALUES ('7', 'test3', '2.7', '', 'Test3', '', '', '0', 'title.asc', '0', '1', '1');
INSERT INTO `sed_tag_references` VALUES ('34', '5', 'forums');
INSERT INTO `sed_tag_references` VALUES ('34 dg', '7', 'forums');
INSERT INTO `sed_tag_references` VALUES ('ajax', '1', 'forums');
INSERT INTO `sed_tag_references` VALUES ('amet', '7', 'pages');
INSERT INTO `sed_tag_references` VALUES ('cotonti', '2', 'forums');
INSERT INTO `sed_tag_references` VALUES ('display image ajax', '1', 'forums');
INSERT INTO `sed_tag_references` VALUES ('dolor', '7', 'pages');
INSERT INTO `sed_tag_references` VALUES ('forum', '2', 'forums');
INSERT INTO `sed_tag_references` VALUES ('ghj', '8', 'forums');
INSERT INTO `sed_tag_references` VALUES ('img', '1', 'forums');
INSERT INTO `sed_tag_references` VALUES ('img tag', '1', 'forums');
INSERT INTO `sed_tag_references` VALUES ('ipsum', '7', 'pages');
INSERT INTO `sed_tag_references` VALUES ('javascript', '1', 'forums');
INSERT INTO `sed_tag_references` VALUES ('jquery', '9', 'forums');
INSERT INTO `sed_tag_references` VALUES ('lorem', '7', 'pages');
INSERT INTO `sed_tag_references` VALUES ('poll', '14', 'forums');
INSERT INTO `sed_tag_references` VALUES ('punishments', '2', 'forums');
INSERT INTO `sed_tag_references` VALUES ('rules', '2', 'forums');
INSERT INTO `sed_tag_references` VALUES ('sit', '7', 'pages');
INSERT INTO `sed_tag_references` VALUES ('tag', '2', 'pages');
INSERT INTO `sed_tag_references` VALUES ('tag', '5', 'pages');
INSERT INTO `sed_tag_references` VALUES ('tagsi', '2', 'pages');
INSERT INTO `sed_tag_references` VALUES ('tagsi', '5', 'pages');
INSERT INTO `sed_tag_references` VALUES ('test', '9', 'forums');
INSERT INTO `sed_tag_references` VALUES ('test', '2', 'pages');
INSERT INTO `sed_tag_references` VALUES ('test', '5', 'pages');
INSERT INTO `sed_tag_references` VALUES ('опрос', '14', 'forums');
INSERT INTO `sed_tags` VALUES ('34');
INSERT INTO `sed_tags` VALUES ('34 dg');
INSERT INTO `sed_tags` VALUES ('ajax');
INSERT INTO `sed_tags` VALUES ('amet');
INSERT INTO `sed_tags` VALUES ('cotonti');
INSERT INTO `sed_tags` VALUES ('display image ajax');
INSERT INTO `sed_tags` VALUES ('dolor');
INSERT INTO `sed_tags` VALUES ('forum');
INSERT INTO `sed_tags` VALUES ('ghj');
INSERT INTO `sed_tags` VALUES ('img');
INSERT INTO `sed_tags` VALUES ('img tag');
INSERT INTO `sed_tags` VALUES ('ipsum');
INSERT INTO `sed_tags` VALUES ('javascript');
INSERT INTO `sed_tags` VALUES ('jquery');
INSERT INTO `sed_tags` VALUES ('lorem');
INSERT INTO `sed_tags` VALUES ('metallica');
INSERT INTO `sed_tags` VALUES ('poll');
INSERT INTO `sed_tags` VALUES ('punishments');
INSERT INTO `sed_tags` VALUES ('rules');
INSERT INTO `sed_tags` VALUES ('sit');
INSERT INTO `sed_tags` VALUES ('tag');
INSERT INTO `sed_tags` VALUES ('tagsi');
INSERT INTO `sed_tags` VALUES ('test');
INSERT INTO `sed_tags` VALUES ('опрос');
INSERT INTO `sed_users` VALUES ('1', '0', 'admin', 'b0baee9d279d34fa1dfd71aadb908c3f', '5', 'by', 'Signature', '', '', '', '', '', '', '', '', '', '', '', '', '', 'Go', '0.0', '1999-11-30', 'M', '', '', '7659985', 'http://cotonti.com', 'dsfsdfs@sdfsdfsd.ru', '1', '0', '1', 'veronese', 'ru', '1249995532', '1255128821', '1255119878', '127.0.0.1', '14152', '17', 'A6214AEC', '17b97fd70144722d88cc836991235698', 'a:12:{s:5:\"admin\";a:1:{s:1:\"a\";i:255;}s:8:\"comments\";a:1:{s:1:\"a\";i:255;}s:6:\"forums\";a:21:{i:1;i:255;i:10;i:255;i:11;i:255;i:12;i:255;i:13;i:255;i:14;i:255;i:15;i:255;i:16;i:255;i:17;i:255;i:18;i:255;i:19;i:255;i:20;i:255;i:21;i:255;i:22;i:255;i:23;i:255;i:3;i:255;i:5;i:255;i:6;i:255;i:7;i:255;i:8;i:255;i:9;i:255;}s:5:\"index\";a:1:{s:1:\"a\";i:255;}s:7:\"message\";a:1:{s:1:\"a\";i:255;}s:4:\"page\";a:7:{s:8:\"articles\";i:255;s:6:\"events\";i:255;s:5:\"links\";i:255;s:4:\"news\";i:255;s:4:\"test\";i:255;s:5:\"test2\";i:255;s:5:\"test3\";i:255;}s:3:\"pfs\";a:1:{s:1:\"a\";i:255;}s:4:\"plug\";a:15:{s:7:\"adminqv\";i:255;s:7:\"cleaner\";i:255;s:7:\"comedit\";i:255;s:10:\"forumstats\";i:255;s:10:\"indexpolls\";i:255;s:8:\"ipsearch\";i:255;s:8:\"markitup\";i:255;s:14:\"massmovetopics\";i:255;s:14:\"newpagesbypath\";i:255;s:11:\"passrecover\";i:255;s:11:\"recentitems\";i:255;s:6:\"search\";i:255;s:10:\"statistics\";i:255;s:4:\"tags\";i:255;s:10:\"whosonline\";i:255;}s:2:\"pm\";a:1:{s:1:\"a\";i:255;}s:5:\"polls\";a:1:{s:1:\"a\";i:255;}s:7:\"ratings\";a:1:{s:1:\"a\";i:255;}s:5:\"users\";a:1:{s:1:\"a\";i:255;}}', 'veronese', 'b6b35af1d3ee2b25');
INSERT INTO `sed_users` VALUES ('2', '0', 'admin2', 'b0baee9d279d34fa1dfd71aadb908c3f', '4', '00', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '0.0', '1999-11-30', 'U', '', '', '', '', 'admin@admin.sdkaksdka', '1', '0', '0', 'veronese', 'ru', '1254238362', '1255127807', '1254412596', '127.0.0.1', '325', '8', 'A6214AEC', '85d2d2ada115e292e8fdc7d281a2ef11', 'a:12:{s:5:\"admin\";a:1:{s:1:\"a\";i:0;}s:8:\"comments\";a:1:{s:1:\"a\";i:3;}s:6:\"forums\";a:21:{i:1;i:3;i:10;i:3;i:11;i:3;i:12;i:3;i:13;i:3;i:14;i:3;i:15;i:3;i:16;i:3;i:17;i:3;i:18;i:3;i:19;i:3;i:20;i:3;i:21;i:3;i:22;i:3;i:23;i:3;i:3;i:3;i:5;i:3;i:6;i:3;i:7;i:3;i:8;i:3;i:9;i:3;}s:5:\"index\";a:1:{s:1:\"a\";i:1;}s:7:\"message\";a:1:{s:1:\"a\";i:1;}s:4:\"page\";a:7:{s:8:\"articles\";i:7;s:6:\"events\";i:7;s:5:\"links\";i:7;s:4:\"news\";i:7;s:4:\"test\";i:7;s:5:\"test2\";i:7;s:5:\"test3\";i:7;}s:3:\"pfs\";a:1:{s:1:\"a\";i:3;}s:4:\"plug\";a:15:{s:7:\"adminqv\";i:1;s:7:\"cleaner\";i:1;s:7:\"comedit\";i:1;s:10:\"forumstats\";i:1;s:10:\"indexpolls\";i:1;s:8:\"ipsearch\";i:0;s:8:\"markitup\";i:3;s:14:\"massmovetopics\";i:0;s:14:\"newpagesbypath\";i:1;s:11:\"passrecover\";i:1;s:11:\"recentitems\";i:1;s:6:\"search\";i:1;s:10:\"statistics\";i:1;s:4:\"tags\";i:3;s:10:\"whosonline\";i:1;}s:2:\"pm\";a:1:{s:1:\"a\";i:3;}s:5:\"polls\";a:1:{s:1:\"a\";i:3;}s:7:\"ratings\";a:1:{s:1:\"a\";i:3;}s:5:\"users\";a:1:{s:1:\"a\";i:3;}}', 'veronese', '53148880405dac24');
